local MinBuild, MaxBuild, Build = 40000, 0, select(4, GetBuildInfo())
if Build < MinBuild or ( MaxBuild > 0 and Build > MaxBuild ) then return end
local AddonName, AddonTable = ...
local L = AddonTable.Localize
LibStub:GetLibrary("BigLibTimer3"):Register(AddonTable)
SpellFlashAddon = {}
local s = SpellFlashAddon
local GetSpellInfo = SpellFlashCore.GetSpellInfo
local GetItemInfo = SpellFlashCore.GetItemInfo
s.SpellName = SpellFlashCore.SpellName
s.ItemName = SpellFlashCore.ItemName
s.Replace = SpellFlashCore.Replace
s.CopyTable = SpellFlashCore.CopyTable


local MAXDEBUFFSLOTS = 40

local MELEESPELL = {
	DEATHKNIGHT = 45902--[[Blood Strike]],
	DRUID = 1082--[[Claw]],
	HUNTER = 2973--[[Raptor Strike]],
	PALADIN = 35395--[[Crusader Strike]],
	ROGUE = 1752--[[Sinister Strike]],
	SHAMAN = 73899--[[Primal Strike]],
	WARRIOR = 78--[[Heroic Strike]],
}

local GLOBALCOOLDOWNSPELL = {
	DEATHKNIGHT = 47541--[[Death Coil]],
	DRUID = 5176--[[Wrath]],
	HUNTER = 883--[[Call Pet 1]],
	MAGE = 133--[[Fireball]],
	PALADIN = 635--[[Holy Light]],
	PRIEST = 585--[[Smite]],
	ROGUE = 1752--[[Sinister Strike]],
	SHAMAN = 403--[[Lightning Bolt]],
	WARLOCK = 686--[[Shadow Bolt]],
	WARRIOR = 772--[[Rend]],
}

local HEALERCLASS = {
	DRUID = "Druid",
	PALADIN = "Paladin",
	PRIEST = "Priest",
	SHAMAN = "Shaman",
}

local ALTERNATEFORM = {
	[s.SpellName(33943--[[Flight Form]], 1)] = s.SpellName(40120--[[Swift Flight Form]], 1),
	[s.SpellName(40120--[[Swift Flight Form]], 1)] = s.SpellName(33943--[[Flight Form]], 1),
}

AddonTable.ImmunityDebuffs = {
	710--[[Banish]],
	33786--[[Cyclone]],
	--605--[[Mind Control]],
}

AddonTable.BreakOnDamage = {
	19503--[[Scatter Shot]],
	1499--[[Freezing Trap]],
	6358--[[Seduction]],
	9484--[[Shackle Undead]],
	6770--[[Sap]],
	118--[[Polymorph]],
	51514--[[Hex]],
	2094--[[Blind]],
	2637--[[Hibernate]],
	76780--[[Bind Elemental]],
	--19386--[[Wyvern Sting]],
}

AddonTable.Fear = {
	5782--[[Fear]],
	5484--[[Howl of Terror]],
	8122--[[Psychic Scream]],
	1513--[[Scare Beast]],
	10326--[[Turn Evil]],
	5246--[[Intimidating Shout]],
}

AddonTable.Root = {
	339--[[Entangling Roots]],
	122--[[Frost Nova]],
	45524--[[Chains of Ice]],
	16979--[[Feral Charge - Bear]],
}

AddonTable.MovementImpairing = {
	5116--[[Concussive Shot]],
	2974--[[Wing Clip]],
	13809--[[Ice Trap]],
	116--[[Frostbolt]],
	120--[[Cone of Cold]],
	11113--[[Blast Wave]],
	31589--[[Slow]],
	15407--[[Mind Flay]],
	3408--[[Crippling Poison]],
	26679--[[Deadly Throw]],
	8056--[[Frost Shock]],
	2484--[[Earthbind Totem]],
	18223--[[Curse of Exhaustion]],
	1715--[[Hamstring]],
	12323--[[Piercing Howl]],
}

AddonTable.PetActions = {
	Attack = "PET_ACTION_ATTACK",
	Follow = "PET_ACTION_FOLLOW",
	Stay = "PET_ACTION_WAIT",
	["Move To"] = "PET_ACTION_MOVE_TO",
	Aggressive = "PET_MODE_AGGRESSIVE",
	Defensive = "PET_MODE_DEFENSIVE",
	Passive = "PET_MODE_PASSIVE",
	PET_ACTION_ATTACK = "PET_ACTION_ATTACK",
	PET_ACTION_FOLLOW = "PET_ACTION_FOLLOW",
	PET_ACTION_WAIT = "PET_ACTION_WAIT",
	PET_ACTION_MOVE_TO = "PET_ACTION_MOVE_TO",
	PET_MODE_AGGRESSIVE = "PET_MODE_AGGRESSIVE",
	PET_MODE_DEFENSIVE = "PET_MODE_DEFENSIVE",
	PET_MODE_PASSIVE = "PET_MODE_PASSIVE",
	[PET_ACTION_ATTACK or "PET_ACTION_ATTACK"] = "PET_ACTION_ATTACK",
	[PET_ACTION_FOLLOW or "PET_ACTION_FOLLOW"] = "PET_ACTION_FOLLOW",
	[PET_ACTION_WAIT or "PET_ACTION_WAIT"] = "PET_ACTION_WAIT",
	[PET_ACTION_MOVE_TO or "PET_ACTION_MOVE_TO"] = "PET_ACTION_MOVE_TO",
	[PET_MODE_AGGRESSIVE or "PET_MODE_AGGRESSIVE"] = "PET_MODE_AGGRESSIVE",
	[PET_MODE_DEFENSIVE or "PET_MODE_DEFENSIVE"] = "PET_MODE_DEFENSIVE",
	[PET_MODE_PASSIVE or "PET_MODE_PASSIVE"] = "PET_MODE_PASSIVE",
}

-- http://www.wowhead.com/npcs?filter=cr=34;crs=0;crv=270
AddonTable.DummyIDNumbers = {
	["1921"] = "Combat Dummy",
	["32542"] = "Disciple's Training Dummy",
	["25297"] = "Drill Dummy",
	["32546"] = "Ebon Knight's Training Dummy",
	["17059"] = "Hellfire Combat Dummy",
	["17060"] = "Hellfire Combat Dummy Small",
	["17578"] = "Hellfire Training Dummy",
	["32547"] = "Highlord's Nemesis Trainer",
	["32541"] = "Initiate's Training Dummy",
	["32545"] = "Initiate's Training Dummy",
	["33229"] = "Melee Target",
	["19139"] = "Nagrand Target Dummy",
	["16211"] = "Naxxramas Combat Dummy",
	["42328"] = "Practice Dummy",
	["25225"] = "Practice Dummy",
	["31146"] = "Raider's Training Dummy",
	["18504"] = "Silvermoon Practice Dummy",
	["43560"] = "Smilin' Timmy Sticks",
	["4952"] = "Theramore Combat Dummy",
	["38038"] = "Tiki Target",
	["44171"] = "Training Dummy",
	["48304"] = "Training Dummy",
	["44937"] = "Training Dummy",
	["44389"] = "Training Dummy",
	["44614"] = "Training Dummy",
	["44548"] = "Training Dummy",
	["44703"] = "Training Dummy",
	["44794"] = "Training Dummy",
	["44820"] = "Training Dummy",
	["44848"] = "Training Dummy",
	["32666"] = "Training Dummy",
	["32667"] = "Training Dummy",
	["31144"] = "Training Dummy",
	["46647"] = "Training Dummy",
	["5652"] = "Undercity Practice Dummy",
	["32543"] = "Veteran's Training Dummy",
}


local DEFAULT_FLASH_SIZE_PERCENT = 240
local DEFAULT_FLASH_BRIGHTNESS_PERCENT = 100
local FLASH_SIZE_PERCENT = DEFAULT_FLASH_SIZE_PERCENT
local FLASH_BRIGHTNESS_PERCENT = DEFAULT_FLASH_BRIGHTNESS_PERCENT
local ENABLE_BLINKING = nil
local DISABLE_MACRO_FLASHING = nil
local SUPPRESS_RANGE_CHECK = nil
local SUPPRESS_SPEED_CHECK = nil
local CLASS = select(2, UnitClass("player"))
local RACE = select(2, UnitRace("player")):upper():gsub("[^A-Z]", ""):gsub("^SCOURGE$", "UNDEAD")
s.L = s.CopyTable(L)
s.Spam = {}
s.UpdatedVariables = {}
local SettingsListenerFunctions = {}
local OtherAurasFunctions = {}
local OtherAurasFromSpell = {}
local OtherAurasSpellFromAura = {}
local SPELLDELAY = {}
local MODIFIEDCLICKFOCUSCAST = nil
local CHANGEDMODIFIEDCLICKFOCUSCAST = nil
local OUTSIDEMELEESPELL = nil
local VARIABLES_CHECKED = nil
local SPELLS = {}
local PET_SPELLS = {}
local TALENTRANK = {}
local TALENTTREEPOINTS = {}
local TALENTMASTERY = nil
local CLASSMODULES = {}
local CLASSMODULES_ADDONNAMES = {}
local GLOBAL_COOLDOWN_SPELL = nil
local CURRENTFORM = nil
local SHOOT = nil
local SERVER = nil
local REALM = nil
local PLAYER = nil
local LOADING = true
local parent = "SpellFlashAddonOptionsFrame"

--[[
s.PRIEST
s.ROGUE
s.PALADIN
s.WARLOCK
s.WARRIOR
s.HUNTER
s.MAGE
s.SHAMAN
s.DRUID
s.DEATHKNIGHT
]]
s[CLASS] = {}

--[[
s.HUMAN
s.DWARF
s.GNOME
s.NIGHTELF
s.BLOODELF
s.ORC
s.UNDEAD
s.TAUREN
s.TROLL
s.DRAENEI
]]
s[RACE] = {}

local function Paste(text, title)
	StaticPopupDialogs[AddonName] = StaticPopupDialogs[AddonName] or {
		text = "%s",
		button2 = CLOSE,
		timeout = 0,
		hasEditBox = true,
		hasWideEditBox = true,
		editBoxWidth = 350,
		whileDead = true,
		hideOnEscape = true,
		enterClicksFirstButton = true,
		EditBoxOnEscapePressed = function(self) self:GetParent():Hide() end,
        OnShow = function(self)
			local editBox = self.wideEditBox or self.editBox
			local button = self.button2
			self:SetWidth(420)
			editBox:SetText(tostring(StaticPopupDialogs[AddonName].editBoxText))
			editBox:SetFocus()
			editBox:HighlightText()
			button:ClearAllPoints()
			button:SetPoint("CENTER", editBox, "CENTER", 0, -30)
		end,
	}
	StaticPopupDialogs[AddonName].editBoxText = text
	StaticPopup_Show(AddonName, title or ( select(2, GetAddOnInfo(AddonName)) ))
end

local function DecodeItemLink(link)
	if type(link) == "string" then
		local id, name = link:match("item:(%d+):.*%[(.*)%]")
		if id then
			return name, tonumber(id)
		end
	end
	return nil
end

local function ItemIDFromItemName(ItemName)
	if type(ItemName) == "string" then
		return ( select(2, DecodeItemLink(select(2, GetItemInfo(ItemName)))) )
	end
	return nil
end

local function ItemSubType(ItemID)
	if ItemID then
		return ( select(7, GetItemInfo(ItemID)) )
	end
	return nil
end

local function UnitIsDummy(unit)
	local Type, ID = s.UnitInfo(unit)
	if Type == "npc" then
		return AddonTable.DummyIDNumbers[tostring(ID)]
	end
	return nil
end

local function VehicleSlot(SpellName)
	if UnitInVehicle("player") then
		local SpellName = s.SpellName(SpellName)
		if SpellName then
			for i = 121, 132 do
				local name = s.SpellName((select(2, GetActionInfo(i))))
				if name and name == SpellName then
					return i
				end
			end
		end
	end
	return nil
end

local function CheckVariables()
	PLAYER = UnitName("player")
	if not PLAYER then
		--Character name not available yet
		return AddonTable:SetTimer("CheckVariables", 1, 0, CheckVariables)
	end
	REALM = GetRealmName()
	SERVER = GetCVar("realmList"):lower()
	if not SpellFlashAddonConfig then
		SpellFlashAddonConfig = {}
	end
	if not SpellFlashAddonConfig.SERVER then
		SpellFlashAddonConfig.SERVER = {}
	end
	if not SpellFlashAddonConfig.SERVER[SERVER] then
		SpellFlashAddonConfig.SERVER[SERVER] = {}
	end
	if not SpellFlashAddonConfig.SERVER[SERVER].REALM then
		SpellFlashAddonConfig.SERVER[SERVER].REALM = {}
	end
	if not SpellFlashAddonConfig.SERVER[SERVER].REALM[REALM] then
		SpellFlashAddonConfig.SERVER[SERVER].REALM[REALM] = {}
	end
	if not SpellFlashAddonConfig.SERVER[SERVER].REALM[REALM].PLAYER then
		SpellFlashAddonConfig.SERVER[SERVER].REALM[REALM].PLAYER = {}
	end
	if not SpellFlashAddonConfig.SERVER[SERVER].REALM[REALM].PLAYER[PLAYER] then
		SpellFlashAddonConfig.SERVER[SERVER].REALM[REALM].PLAYER[PLAYER] = {}
	end
	if not SpellFlashAddonConfig.SERVER[SERVER].REALM[REALM].PLAYER[PLAYER].MODULE then
		SpellFlashAddonConfig.SERVER[SERVER].REALM[REALM].PLAYER[PLAYER].MODULE = {}
	end
	--if not (SERVER:match("%.worldofwarcraft%.com$") or SERVER:match("%.battle%.net$")) then  end
	SpellFlashAddonConfig.SERVER[SERVER].Immune = nil
	SpellFlashAddonConfig.SERVER[SERVER].ImmuneIgnore = nil
	FLASH_SIZE_PERCENT = SpellFlashAddonConfig.SERVER[SERVER].REALM[REALM].PLAYER[PLAYER].flash_size_percent or DEFAULT_FLASH_SIZE_PERCENT
	FLASH_BRIGHTNESS_PERCENT = SpellFlashAddonConfig.SERVER[SERVER].REALM[REALM].PLAYER[PLAYER].flash_brightness_percent or DEFAULT_FLASH_BRIGHTNESS_PERCENT
	DISABLE_MACRO_FLASHING = SpellFlashAddonConfig.SERVER[SERVER].REALM[REALM].PLAYER[PLAYER].disable_macro_flashing
	SUPPRESS_RANGE_CHECK = SpellFlashAddonConfig.SERVER[SERVER].REALM[REALM].PLAYER[PLAYER].suppress_range_check
	SUPPRESS_SPEED_CHECK = SpellFlashAddonConfig.SERVER[SERVER].REALM[REALM].PLAYER[PLAYER].suppress_speed_check
	ENABLE_BLINKING = SpellFlashAddonConfig.SERVER[SERVER].REALM[REALM].PLAYER[PLAYER].enable_blinking
	VARIABLES_CHECKED = 1
end

local function LoadAddOns()
	local Loaded, Error
	for i = 1, GetNumAddOns() do
		local name, title, notes, enabled = GetAddOnInfo(i)
		if enabled and not name:lower():match("^spellflash_templateaddon$") then
			local Metadata = GetAddOnMetadata(name, "X-SpellFlashAddon-LoadWith") or ""
			if Metadata:match("%w") then
				local LoadWith = ","..Metadata:upper():gsub("[^A-Z,%+]", ""):gsub("%+", "++")..","
				if LoadWith:match(",ANY,")
				or LoadWith:match(","..CLASS..",")
				or LoadWith:match(","..RACE..",")
				or LoadWith:match("[,%+]"..CLASS.."%+".."[^,]*".."%+"..RACE.."[,%+]")
				or LoadWith:match("[,%+]"..RACE.."%+".."[^,]*".."%+"..CLASS.."[,%+]")
				or LoadWith:match("[,%+]"..CLASS.."%+".."[^,]*".."%+ANY[,%+]")
				or LoadWith:match("[,%+]"..RACE.."%+".."[^,]*".."%+ANY[,%+]")
				or LoadWith:match("[,%+]ANY%+".."[^,]*".."%+"..CLASS.."[,%+]")
				or LoadWith:match("[,%+]ANY%+".."[^,]*".."%+"..RACE.."[,%+]")
				then
					Loaded = IsAddOnLoaded(i)
					if not Loaded and IsAddOnLoadOnDemand(i) then
						Loaded, Error = LoadAddOn(name)
						if not Loaded then
							print("Error loading: "..name.." ("..Error..")")
						end
					end
					if Loaded and LoadWith:match(","..CLASS..",") then
						CLASSMODULES[name] = title.."   "..GRAY_FONT_COLOR_CODE.."("..name..")"..FONT_COLOR_CODE_CLOSE
						CLASSMODULES_ADDONNAMES[CLASSMODULES[name]] = name
					end
				end
			end
		end
	end
	if not SpellFlashAddonConfig.SERVER[SERVER].REALM[REALM].PLAYER[PLAYER].selected_class_module or not CLASSMODULES[SpellFlashAddonConfig.SERVER[SERVER].REALM[REALM].PLAYER[PLAYER].selected_class_module] then
		local name = next(CLASSMODULES)
		if tostring(name):lower():match("^spellflash_x$") then
			local nextname = next(CLASSMODULES, name)
			if nextname then
				name = nextname
			end
		end
		SpellFlashAddonConfig.SERVER[SERVER].REALM[REALM].PLAYER[PLAYER].selected_class_module = name
	end
	local function Initialize(frame, level)
		for _, v in pairs(CLASSMODULES) do
			local info = UIDropDownMenu_CreateInfo()
			info.text = v
			info.func = function(self)
				UIDropDownMenu_SetSelectedID(frame, self:GetID())
			end
			UIDropDownMenu_AddButton(info, level)
		end
	end
	UIDropDownMenu_Initialize(_G[parent.."ClassModulesList"], Initialize)
	if next(CLASSMODULES) then
		UIDropDownMenu_SetSelectedName(_G[parent.."ClassModulesList"], CLASSMODULES[SpellFlashAddonConfig.SERVER[SERVER].REALM[REALM].PLAYER[PLAYER].selected_class_module])
		UIDropDownMenu_SetText(_G[parent.."ClassModulesList"], CLASSMODULES[SpellFlashAddonConfig.SERVER[SERVER].REALM[REALM].PLAYER[PLAYER].selected_class_module])
	end
end

local function RunSpam()
	if not SpellFlashAddonConfig.SERVER[SERVER].REALM[REALM].PLAYER[PLAYER].in_combat_only or InCombatLockdown() then
		local x = s.UpdatedVariables
		x.ActiveEnemy = s.ActiveEnemy()
		x.Enemy = x.ActiveEnemy or s.Enemy()
		x.NoCC = x.ActiveEnemy or not s.NoDamageCC()
		x.PetAlive = UnitHealth("pet") > 0
		x.PetActiveEnemy = x.PetAlive and s.ActiveEnemy("pettarget")
		x.PetNoCC = not x.PetAlive or x.PetActiveEnemy or not s.BreakOnDamageCC("pettarget")
		x.InInstance, x.InstanceType = IsInInstance()
		x.Lag = select(3, GetNetStats()) / 1000
		x.DoubleLag = x.Lag * 2
		x.ThreatPercent = select(3, UnitDetailedThreatSituation("player", s.UnitSelection())) or 0
		x.EnemyDetected = s.InCombat() or x.Enemy or s.Enemy("mouseover") or s.Enemy("focus") or s.Enemy("enemy")
		x.ShouldPermanentBuff = not UnitIsDeadOrGhost("player") and HasFullControl() and not IsMounted() and not UnitOnTaxi("player") and not UnitInVehicle("player")
		x.ShouldTemporaryBuff = x.ShouldPermanentBuff and ( x.EnemyDetected or not IsResting() )
		for n, v in pairs(s.Spam) do
			if type(v) == "function" and ( not CLASSMODULES[n] or SpellFlashAddonConfig.SERVER[SERVER].REALM[REALM].PLAYER[PLAYER].selected_class_module == n or SpellFlashAddonConfig.SERVER[SERVER].REALM[REALM].PLAYER[PLAYER].use_all_class_modules ) then
				v(x)
			end
		end
	end
end

local function SetSpam()
	if not SpellFlashAddonConfig.SERVER[SERVER].REALM[REALM].PLAYER[PLAYER].spell_flashing_off then
		if not AddonTable:IsTimer("Spam-repeat") then
			AddonTable:SetTimer("Spam-repeat", 0, 0.2, RunSpam)
		end
	else
		AddonTable:ClearTimer("Spam-repeat")
	end
end

local function RegisterOtherAuras()
	wipe(OtherAurasFromSpell)
	for Function in pairs(OtherAurasFunctions) do
		Function()
	end
	wipe(OtherAurasSpellFromAura)
	for Spell, t in pairs(OtherAurasFromSpell) do
		for Aura in pairs(t) do
			if not OtherAurasSpellFromAura[Aura] then
				OtherAurasSpellFromAura[Aura] = {}
			end
			OtherAurasSpellFromAura[Aura][Spell] = 1
		end
	end
end

-- Registers the current Form or Stance
local function RegisterForm()
	local n = GetShapeshiftForm()
	if not n or n == 0 then
		CURRENTFORM = nil
	else
		CURRENTFORM = select(2, GetShapeshiftFormInfo(n))
	end
	SpellFlashCore.debug("Now in "..( CURRENTFORM or "Caster Form" ).."!")
end

local function RegisterSpells()
	wipe(SPELLS)
	local i = 1
	local spellName, spellSubName = GetSpellBookItemName(i, BOOKTYPE_SPELL)
	while spellName do
		local skillType, spellId = GetSpellBookItemInfo(i, "player")
		if skillType == "SPELL" then
			if spellSubName and spellSubName ~= "" then
				spellName = spellName.."("..spellSubName..")"
			end
			SPELLS[spellName] = spellId
			--print(BOOKTYPE_SPELL, i, spellName, spellId)
		end
		i = i + 1
		spellName, spellSubName = GetSpellBookItemName(i, BOOKTYPE_SPELL)
	end
end

local function RegisterPetSpells()
	wipe(PET_SPELLS)
	local i = 1
	local spellName, spellSubName = GetSpellBookItemName(i, BOOKTYPE_PET)
	while spellName do
		local skillType, spellId = GetSpellBookItemInfo(i, "pet")
		if skillType == "SPELL" then
			if spellSubName and spellSubName ~= "" then
				spellName = spellName.."("..spellSubName..")"
			end
			PET_SPELLS[spellName] = spellId
			--print(BOOKTYPE_PET, i, spellName, spellId)
		end
		i = i + 1
		spellName, spellSubName = GetSpellBookItemName(i, BOOKTYPE_PET)
	end
end

local function RegisterTalents()
	TALENTMASTERY = nil
	local HighestTreeFound = 0
	for Tab = 1, GetNumTalentTabs() do
		TALENTTREEPOINTS[Tab] = 0
		for Tal = 1, GetNumTalents(Tab) do
			local name, icon, tier, column, rank = GetTalentInfo(Tab, Tal)
			if name then
				TALENTRANK[name] = rank
				TALENTTREEPOINTS[Tab] = TALENTTREEPOINTS[Tab] + rank
			end
		end
		if TALENTTREEPOINTS[Tab] > 0 and TALENTTREEPOINTS[Tab] > HighestTreeFound then
			HighestTreeFound = TALENTTREEPOINTS[Tab]
			TALENTMASTERY = Tab
		end
	end
end

local function RegisterOutsideMeleeDistanceSpell()
	if not s.HasSpell(MELEESPELL[CLASS]) then
		OUTSIDEMELEESPELL = nil
		local i = 1
		local skillType, spellId = GetSpellBookItemInfo(i, "player")
		while skillType do
			if skillType == "SPELL" and s.SpellHasRange(spellId) and select(8,GetSpellInfo(spellId)) == 5 and select(9,GetSpellInfo(spellId)) >= 10 then
				OUTSIDEMELEESPELL = spellId
				break
			end
			i = i + 1
			skillType, spellId = GetSpellBookItemInfo(i, "player")
		end
	end
end

function SpellFlashAddon.OpenToClassCategory()
	local AddonName = CLASSMODULES_ADDONNAMES[UIDropDownMenu_GetText(_G[parent.."ClassModulesList"])]
	if AddonName and _G[AddonName.."_SpellFlashAddonOptionsFrame"] then
		InterfaceOptionsFrame_OpenToCategory(_G[AddonName.."_SpellFlashAddonOptionsFrame"])
	end
end

function SpellFlashAddon.TestFlashSettings()
	local sizepercent = _G[parent.."FlashSizePercent"]:GetNumber()
	if sizepercent > 0 then
		FLASH_SIZE_PERCENT = sizepercent
	else
		FLASH_SIZE_PERCENT = DEFAULT_FLASH_SIZE_PERCENT
	end
	local brightnesspercent = _G[parent.."FlashBrightnessPercent"]:GetNumber()
	if brightnesspercent > 0 and brightnesspercent < 100 then
		FLASH_BRIGHTNESS_PERCENT = brightnesspercent
	else
		FLASH_BRIGHTNESS_PERCENT = DEFAULT_FLASH_BRIGHTNESS_PERCENT
	end
end

local function ResetFlashSettings()
	FLASH_SIZE_PERCENT = SpellFlashAddonConfig.SERVER[SERVER].REALM[REALM].PLAYER[PLAYER].flash_size_percent or DEFAULT_FLASH_SIZE_PERCENT
	FLASH_BRIGHTNESS_PERCENT = SpellFlashAddonConfig.SERVER[SERVER].REALM[REALM].PLAYER[PLAYER].flash_brightness_percent or DEFAULT_FLASH_BRIGHTNESS_PERCENT
end

local function ResetDefaults()
	SpellFlashAddonConfig.SERVER[SERVER].REALM[REALM].PLAYER[PLAYER].spell_flashing_off = nil
	SpellFlashAddonConfig.SERVER[SERVER].REALM[REALM].PLAYER[PLAYER].enable_blinking = nil
	SpellFlashAddonConfig.SERVER[SERVER].REALM[REALM].PLAYER[PLAYER].disable_macro_flashing = nil
	SpellFlashAddonConfig.SERVER[SERVER].REALM[REALM].PLAYER[PLAYER].use_all_class_modules = nil
	SpellFlashAddonConfig.SERVER[SERVER].REALM[REALM].PLAYER[PLAYER].suppress_range_check = nil
	SpellFlashAddonConfig.SERVER[SERVER].REALM[REALM].PLAYER[PLAYER].suppress_speed_check = nil
	SpellFlashAddonConfig.SERVER[SERVER].REALM[REALM].PLAYER[PLAYER].flash_size_percent = nil
	SpellFlashAddonConfig.SERVER[SERVER].REALM[REALM].PLAYER[PLAYER].flash_brightness_percent = nil
	SpellFlashAddonConfig.SERVER[SERVER].REALM[REALM].PLAYER[PLAYER].in_combat_only = nil
	SpellFlashAddonConfig.SERVER[SERVER].REALM[REALM].PLAYER[PLAYER].disable_default_proc_highlighting = nil
	CheckVariables()
	SetSpam()
end

local function LoadOptionsFrameSettings()
	if next(CLASSMODULES) then
		UIDropDownMenu_SetSelectedName(_G[parent.."ClassModulesList"], CLASSMODULES[SpellFlashAddonConfig.SERVER[SERVER].REALM[REALM].PLAYER[PLAYER].selected_class_module])
		UIDropDownMenu_SetText(_G[parent.."ClassModulesList"], CLASSMODULES[SpellFlashAddonConfig.SERVER[SERVER].REALM[REALM].PLAYER[PLAYER].selected_class_module])
	end
	SpellFlashAddonOptionsFrame_SpellFlashing:SetChecked(not SpellFlashAddonConfig.SERVER[SERVER].REALM[REALM].PLAYER[PLAYER].spell_flashing_off)
	_G[parent.."BlinkSpells"]:SetChecked(SpellFlashAddonConfig.SERVER[SERVER].REALM[REALM].PLAYER[PLAYER].enable_blinking)
	_G[parent.."disable_macro_flashing"]:SetChecked(not SpellFlashAddonConfig.SERVER[SERVER].REALM[REALM].PLAYER[PLAYER].disable_macro_flashing)
	_G[parent.."UseAllClassModules"]:SetChecked(SpellFlashAddonConfig.SERVER[SERVER].REALM[REALM].PLAYER[PLAYER].use_all_class_modules)
	_G[parent.."suppress_range_check"]:SetChecked(not SpellFlashAddonConfig.SERVER[SERVER].REALM[REALM].PLAYER[PLAYER].suppress_range_check)
	_G[parent.."suppress_speed_check"]:SetChecked(not SpellFlashAddonConfig.SERVER[SERVER].REALM[REALM].PLAYER[PLAYER].suppress_speed_check)
	_G[parent.."FlashSizePercent"]:SetNumber(SpellFlashAddonConfig.SERVER[SERVER].REALM[REALM].PLAYER[PLAYER].flash_size_percent or DEFAULT_FLASH_SIZE_PERCENT)
	_G[parent.."FlashBrightnessPercent"]:SetNumber(SpellFlashAddonConfig.SERVER[SERVER].REALM[REALM].PLAYER[PLAYER].flash_brightness_percent or DEFAULT_FLASH_BRIGHTNESS_PERCENT)
	_G[parent.."in_combat_only"]:SetChecked(SpellFlashAddonConfig.SERVER[SERVER].REALM[REALM].PLAYER[PLAYER].in_combat_only)
	_G[parent.."disable_default_proc_highlighting"]:SetChecked(not SpellFlashAddonConfig.SERVER[SERVER].REALM[REALM].PLAYER[PLAYER].disable_default_proc_highlighting)
end

local function SaveOptionsFrameSettings()
	if next(CLASSMODULES) then
		SpellFlashAddonConfig.SERVER[SERVER].REALM[REALM].PLAYER[PLAYER].selected_class_module = CLASSMODULES_ADDONNAMES[UIDropDownMenu_GetText(_G[parent.."ClassModulesList"])]
	end
	SpellFlashAddonConfig.SERVER[SERVER].REALM[REALM].PLAYER[PLAYER].spell_flashing_off = not SpellFlashAddonOptionsFrame_SpellFlashing:GetChecked() or nil
	SpellFlashAddonConfig.SERVER[SERVER].REALM[REALM].PLAYER[PLAYER].enable_blinking = not not _G[parent.."BlinkSpells"]:GetChecked() or nil
	SpellFlashAddonConfig.SERVER[SERVER].REALM[REALM].PLAYER[PLAYER].disable_macro_flashing = not _G[parent.."disable_macro_flashing"]:GetChecked() or nil
	SpellFlashAddonConfig.SERVER[SERVER].REALM[REALM].PLAYER[PLAYER].use_all_class_modules = not not _G[parent.."UseAllClassModules"]:GetChecked() or nil
	SpellFlashAddonConfig.SERVER[SERVER].REALM[REALM].PLAYER[PLAYER].suppress_range_check = not _G[parent.."suppress_range_check"]:GetChecked() or nil
	SpellFlashAddonConfig.SERVER[SERVER].REALM[REALM].PLAYER[PLAYER].suppress_speed_check = not _G[parent.."suppress_speed_check"]:GetChecked() or nil
	SpellFlashAddonConfig.SERVER[SERVER].REALM[REALM].PLAYER[PLAYER].in_combat_only = not not _G[parent.."in_combat_only"]:GetChecked() or nil
	SpellFlashAddonConfig.SERVER[SERVER].REALM[REALM].PLAYER[PLAYER].disable_default_proc_highlighting = not _G[parent.."disable_default_proc_highlighting"]:GetChecked() or nil
	local sizepercent = _G[parent.."FlashSizePercent"]:GetNumber()
	if sizepercent > 0 and sizepercent ~= DEFAULT_FLASH_SIZE_PERCENT then
		SpellFlashAddonConfig.SERVER[SERVER].REALM[REALM].PLAYER[PLAYER].flash_size_percent = sizepercent
	else
		SpellFlashAddonConfig.SERVER[SERVER].REALM[REALM].PLAYER[PLAYER].flash_size_percent = nil
	end
	local brightnesspercent = _G[parent.."FlashBrightnessPercent"]:GetNumber()
	if brightnesspercent > 0 and brightnesspercent < 100 then
		SpellFlashAddonConfig.SERVER[SERVER].REALM[REALM].PLAYER[PLAYER].flash_brightness_percent = brightnesspercent
	else
		SpellFlashAddonConfig.SERVER[SERVER].REALM[REALM].PLAYER[PLAYER].flash_brightness_percent = nil
	end
	CheckVariables()
	SetSpam()
	for Function in pairs(SettingsListenerFunctions) do
		Function()
	end
end

local function LocalizeFontStrings(frame)
	for _, f in next, {frame:GetChildren()} do
		if f:GetObjectType() == "FontString" then
			f:SetText(L[f:GetText()])
		else
			for _, f in next, {f:GetRegions()} do
				if f:GetObjectType() == "FontString" then
					f:SetText(L[f:GetText()])
				end
			end
		end
	end
end

function SpellFlashAddon.OptionsFrame_OnLoad(self)
	
	LocalizeFontStrings(self)
	
	_G[self:GetName().."TitleString"]:SetText(select(2, GetAddOnInfo(AddonName)).." "..GetAddOnMetadata(AddonName, "Version"))
	
	-- Set the name for the Category for the Panel
	self.name = select(2, GetAddOnInfo(AddonName))
	
	-- When the player clicks okay, run this function.
	self.okay = SaveOptionsFrameSettings
	
	-- When the player clicks cancel, run this function.
	self.cancel = ResetFlashSettings
	
	-- This is a function that is called when the player presses the Default Button.
	self.default = ResetDefaults
	
	-- This will run whenever the options frame is loaded or after defaults are loaded.
	self.refresh = LoadOptionsFrameSettings
	
	-- Add the panel to the Interface Options
	InterfaceOptions_AddCategory(self)
	
end


local Event = {}
local function OnEvent(self, event, ...)
	Event[event](event, ...)
end
local EventFrame = CreateFrame("Frame")
EventFrame:SetScript("OnEvent", OnEvent)

function Event.START_AUTOREPEAT_SPELL(event, ...)
	SHOOT = 1
end

function Event.STOP_AUTOREPEAT_SPELL(event, ...)
	SHOOT = nil
end

function Event.UPDATE_SHAPESHIFT_FORM(event, ...)
	RegisterForm()
end

function Event.COMBAT_LOG_EVENT_UNFILTERED(event, ...)
	local Event, sourceGUID, GUID, SpellName, EventType
	if Build >= 40200 then
		Event = select(2, ...)
		sourceGUID = select(4, ...)
		GUID = select(8, ...)
		SpellName = select(13, ...)
		EventType = select(15, ...)
	elseif Build >= 40100 then
		Event = select(2, ...)
		sourceGUID = select(4, ...)
		GUID = select(7, ...)
		SpellName = select(11, ...)
		EventType = select(13, ...)
	else
		Event = select(2, ...)
		sourceGUID = select(3, ...)
		GUID = select(6, ...)
		SpellName = select(10, ...)
		EventType = select(12, ...)
	end
	if EventType == "IMMUNE" and Event ~= "SWING_DAMAGE" and Event ~= "RANGE_DAMAGE" then
		if sourceGUID == UnitGUID("player") or s.HasSpell(SpellName) then
			AddonTable:SetTimer(SpellName.."TempImmune"..GUID, 5)
		end
	end
	if Event == "SPELL_MISS" or Event == "SPELL_MISSED" or Event == "SPELL_DAMAGE" or Event == "SPELL_HEAL" or Event == "SPELL_AURA_REFRESH" or Event == "SPELL_AURA_APPLIED" or Event == "SPELL_AURA_APPLIED_DOSE" then
		if not Event:match("MISS") and Event ~= "SPELL_HEAL" and EventType ~= "BUFF" then
			AddonTable:ClearTimer(SpellName.."TempImmune"..GUID)
		end
		if sourceGUID == UnitGUID("player") then
			local Lag = select(3, GetNetStats()) / 1000
			if OtherAurasFromSpell[SpellName] and not Event:match("MISS") and (SPELLDELAY[SpellName] or 0) > 0 then
				for n in pairs(OtherAurasFromSpell[SpellName]) do
					AddonTable:SetTimer(n.."AuraDelay"..GUID, math.max(1, Lag))
				end
			end
			if not tostring(EventType):match("BUFF") and ( Event == "SPELL_DAMAGE" or Event == "SPELL_HEAL" ) then
				if (SPELLDELAY[SpellName] or 0) > 0 then
					AddonTable:SetTimer(SpellName.."AuraDelay"..GUID, math.max(1, Lag))
				end
			else
				AddonTable:ClearTimer(SpellName.."AuraDelay"..GUID)
			end
			if (SPELLDELAY[SpellName] or 0) > 0 then
				SPELLDELAY[SpellName] = SPELLDELAY[SpellName] - 1
			end
		end
	end
end

function Event.UNIT_SPELLCAST_SUCCEEDED(event, ...)
	if select(1, ...) == "player" then
		local SpellName = select(2, ...)
		AddonTable:SetTimer(SpellName.."ClearSpellDelay", 5, 0,
			function()
				SPELLDELAY[SpellName] = nil
			end
		)
		SPELLDELAY[SpellName] = (SPELLDELAY[SpellName] or 0) + 1
	end
end

function Event.PLAYER_TARGET_CHANGED(event, ...)
	if UnitExists("target") then
		if IsModifiedClick("FOCUSCAST") then
			CHANGEDMODIFIEDCLICKFOCUSCAST = 1
		else
			wipe(SPELLDELAY)
		end
	end
end

function Event.PLAYER_FOCUS_CHANGED(event, ...)
	if UnitExists("focus") then
		if IsModifiedClick("FOCUSCAST") then
			wipe(SPELLDELAY)
		else
			CHANGEDMODIFIEDCLICKFOCUSCAST = 1
		end
	end
end

function Event.MODIFIER_STATE_CHANGED(event, ...)
	if MODIFIEDCLICKFOCUSCAST ~= IsModifiedClick("FOCUSCAST") then
		if CHANGEDMODIFIEDCLICKFOCUSCAST then
			CHANGEDMODIFIEDCLICKFOCUSCAST = nil
			wipe(SPELLDELAY)
		elseif IsModifiedClick("FOCUSCAST") then
			if UnitExists("focus") then
				wipe(SPELLDELAY)
			end
		elseif UnitExists("target") then
			wipe(SPELLDELAY)
		end
		MODIFIEDCLICKFOCUSCAST = IsModifiedClick("FOCUSCAST")
	end
end

local function RegisterAll(event, ...)
	wipe(SPELLDELAY)
	RegisterSpells()
	RegisterPetSpells()
	RegisterTalents()
	RegisterOtherAuras()
	AddonTable:SetTimer("RegisterOutsideMeleeDistanceSpell", 0.5, 0, RegisterOutsideMeleeDistanceSpell)
	if not GLOBAL_COOLDOWN_SPELL and s.HasSpell(GLOBALCOOLDOWNSPELL[CLASS]) then
		GLOBAL_COOLDOWN_SPELL = GLOBALCOOLDOWNSPELL[CLASS]
	end
end
Event.ACTIONBAR_HIDEGRID = RegisterAll
Event.LEARNED_SPELL_IN_TAB = RegisterAll
Event.CHARACTER_POINTS_CHANGED = RegisterAll
Event.ACTIVE_TALENT_GROUP_CHANGED = RegisterAll
Event.SKILL_LINES_CHANGED = RegisterAll
Event.UPDATE_MACROS = RegisterAll

Event.PET_BAR_UPDATE = RegisterPetSpells
Event.PET_TALENT_UPDATE = RegisterPetSpells

local function StartUp(event, ...)
	if LOADING then
		AddonTable:SetTimer("RegisterFunctions", 2, 0,
			function()
				if LOADING then
					if VARIABLES_CHECKED then
						LoadAddOns()
						RegisterSpells()
						RegisterPetSpells()
						RegisterTalents()
						RegisterOtherAuras()
						RegisterOutsideMeleeDistanceSpell()
						if not GLOBAL_COOLDOWN_SPELL and s.HasSpell(GLOBALCOOLDOWNSPELL[CLASS]) then
							GLOBAL_COOLDOWN_SPELL = GLOBALCOOLDOWNSPELL[CLASS]
						end
						RegisterForm()
						SetSpam()
						LOADING = nil
					else
						AddonTable:ReplaceTimer("RegisterFunctions", 2)
					end
				end
			end
		)
	end
	wipe(SPELLDELAY)
end
Event.PLAYER_ENTERING_WORLD = StartUp
Event.PLAYER_ALIVE = StartUp

function Event.ADDON_LOADED(event, ...)
	if select(1, ...) == AddonName then
		CheckVariables()
	end
end

for event in pairs(Event) do
	EventFrame:RegisterEvent(event)
end



_G["SLASH_"..AddonName.."1"] = "/spellflash"
_G["SLASH_"..AddonName.."2"] = "/sflash"
_G["SLASH_"..AddonName.."3"] = "/sf"
SlashCmdList[AddonName] = function(msg)
	local msg = msg:lower()
	if msg:match("reset") or msg:match("clear") or msg:match("wipe") or msg:match("erase") or msg:match("default") then
		VARIABLES_CHECKED = nil
		SpellFlashAddonConfig = nil
		CheckVariables()
		SpellFlashAddonConfig.SERVER[SERVER].REALM[REALM].PLAYER[PLAYER].selected_class_module = next(CLASSMODULES)
		SetSpam()
		LoadOptionsFrameSettings()
		for Function in pairs(SettingsListenerFunctions) do
			Function()
		end
		print(L["SpellFlash settings have been reset for all players"])
	elseif msg:match("debuff") then
		s.ShowDebuffs()
	elseif msg:match("buff") then
		s.ShowBuffs()
	else
		InterfaceOptionsFrame_OpenToCategory(SpellFlashAddonOptionsFrame)
	end
end

CreateFrame("GameTooltip", "SpellFlashAddon_Tooltip", nil, "GameTooltipTemplate")
SpellFlashAddon_Tooltip:SetOwner(WorldFrame, "ANCHOR_NONE")

local function Immune(SpellName, unit)
	local SpellName = s.SpellName(SpellName, 1)
	local GUID = UnitGUID(s.UnitSelection(unit))
	return SpellName and SpellName ~= "" and GUID and AddonTable:IsTimer(SpellName.."TempImmune"..GUID)
end

local function UnitIsBossUnit(unit)
	for i = 1, 4 do
		if UnitExists("boss"..i) and UnitIsUnit(unit, "boss"..i) then
			return true
		end
	end
	return false
end

local WeaponSlotPosition = {mainhandslot = 1, secondaryhandslot = 4, rangedslot = 7}

local function CheckAura(SpellName, unit, DurationRemainingGreaterThan, Stealable, Castable, SpellToolTipLineTwo, Type, owner, GiveExpirationTime, GiveApplications, Debuff)
	if type(unit) == "string" then
		local group = "|"..unit.."|"
		if group:lower():match("|raid|") or group:lower():match("|party|") then
			local u = "player"
			local r = GetNumRaidMembers()
			local p = GetNumPartyMembers()
			if group:lower():match("|all|") then
				if GiveApplications or GiveExpirationTime then
					return 0
				end
				if not UnitIsDeadOrGhost(u) then
					if not group:lower():match("|notself|") and ( not group:lower():match("|healer|") or HEALERCLASS[CLASS] ) then
						if not CheckAura(SpellName, u, DurationRemainingGreaterThan, Stealable, Castable, SpellToolTipLineTwo, Type, owner, GiveExpirationTime, GiveApplications, Debuff) then
							return nil
						end
					end
					if group:lower():match("|raid|") and r > 1 then
						for i = 1, r do
							u = "raid"..i
							if not UnitIsUnit(u, "player") and UnitIsVisible(u) and UnitIsConnected(u) and not UnitIsDeadOrGhost(u) and ( not group:lower():match("|afk|") or not UnitIsAFK(u) ) and ( not group:lower():match("|range|") or UnitInRange(u) ) and ( not group:lower():match("|healer|") or HEALERCLASS[s.Class(u)] ) then
								if not CheckAura(SpellName, u, DurationRemainingGreaterThan, Stealable, Castable, SpellToolTipLineTwo, Type, owner, GiveExpirationTime, GiveApplications, Debuff) then
									return nil
								end
							end
						end
					elseif p > 0 then
						for i = 1, p do
							u = "party"..i
							if UnitIsVisible(u) and UnitIsConnected(u) and not UnitIsDeadOrGhost(u) and ( not group:lower():match("|afk|") or not UnitIsAFK(u) ) and ( not group:lower():match("|range|") or UnitInRange(u) ) and ( not group:lower():match("|healer|") or HEALERCLASS[s.Class(u)] ) then
								if not CheckAura(SpellName, u, DurationRemainingGreaterThan, Stealable, Castable, SpellToolTipLineTwo, Type, owner, GiveExpirationTime, GiveApplications, Debuff) then
									return nil
								end
							end
						end
					end
				end
				return 1
			else
				local remaining = 0
				local result
				if not UnitIsDeadOrGhost(u) then
					if not group:lower():match("|notself|") and ( not group:lower():match("|healer|") or HEALERCLASS[CLASS] ) then
						result = CheckAura(SpellName, u, DurationRemainingGreaterThan, Stealable, Castable, SpellToolTipLineTwo, Type, owner, GiveExpirationTime, GiveApplications, Debuff)
						if result then
							if GiveApplications or GiveExpirationTime then
								if result > remaining then
									remaining = result
								end
							else
								return result
							end
						end
					end
					if group:lower():match("|raid|") and r > 1 then
						for i = 1, r do
							u = "raid"..i
							if not UnitIsUnit(u, "player") and UnitIsVisible(u) and UnitIsConnected(u) and not UnitIsDeadOrGhost(u) and ( not group:lower():match("|afk|") or not UnitIsAFK(u) ) and ( not group:lower():match("|range|") or UnitInRange(u) ) and ( not group:lower():match("|healer|") or HEALERCLASS[s.Class(u)] ) then
								result = CheckAura(SpellName, u, DurationRemainingGreaterThan, Stealable, Castable, SpellToolTipLineTwo, Type, owner, GiveExpirationTime, GiveApplications, Debuff)
								if result then
									if GiveApplications or GiveExpirationTime then
										if result > remaining then
											remaining = result
										end
									else
										return result
									end
								end
							end
						end
					elseif p > 0 then
						for i = 1, p do
							u = "party"..i
							if UnitIsVisible(u) and UnitIsConnected(u) and not UnitIsDeadOrGhost(u) and ( not group:lower():match("|afk|") or not UnitIsAFK(u) ) and ( not group:lower():match("|range|") or UnitInRange(u) ) and ( not group:lower():match("|healer|") or HEALERCLASS[s.Class(u)] ) then
								result = CheckAura(SpellName, u, DurationRemainingGreaterThan, Stealable, Castable, SpellToolTipLineTwo, Type, owner, GiveExpirationTime, GiveApplications, Debuff)
								if result then
									if GiveApplications or GiveExpirationTime then
										if result > remaining then
											remaining = result
										end
									else
										return result
									end
								end
							end
						end
					end
				end
				if GiveApplications or GiveExpirationTime then
					return remaining
				end
				return nil
			end
		end
		if WeaponSlotPosition[unit:lower()] then
			local hasEnchant, Expiration, Charges = select(WeaponSlotPosition[unit:lower()], GetWeaponEnchantInfo())
			if hasEnchant and ( type(DurationRemainingGreaterThan) ~= "number" or DurationRemainingGreaterThan <= 0 or (Expiration or 0) == 0 or Expiration / 1000 > DurationRemainingGreaterThan ) then
				local SpellName = s.SpellName(SpellName, 1)
				if SpellName then
					SpellFlashAddon_Tooltip:ClearLines()
					if SpellFlashAddon_Tooltip:SetInventoryItem("player", (GetInventorySlotInfo(unit))) then
						local regions = select("#", SpellFlashAddon_Tooltip:GetRegions())
						if regions > 0 then
							for i = 1, regions do
								local region = select(i, SpellFlashAddon_Tooltip:GetRegions())
								local text = nil
								if region and region:GetObjectType() == "FontString" then
									text = region:GetText()
								end
								if text and text ~= "" then
									if type(SpellName) == "table" then
										for _, v in ipairs(SpellName) do
											local SpellName = s.SpellName(v, 1)
											if SpellName and text:find(SpellName, nil, true) then
												if GiveApplications then
													if Charges == 0 then
														return 1
													end
													return Charges or 1
												elseif GiveExpirationTime then
													return Expiration / 1000
												end
												return 1
											end
										end
									elseif text:find(SpellName, nil, true) then
										if GiveApplications then
											if Charges == 0 then
												return 1
											end
											return Charges or 1
										elseif GiveExpirationTime then
											return Expiration / 1000
										end
										return 1
									end
								end
							end
						end
					end
				else
					if GiveApplications then
						if Charges == 0 then
							return 1
						end
						return Charges or 1
					elseif GiveExpirationTime then
						return Expiration / 1000
					end
					return 1
				end
			end
			if GiveApplications or GiveExpirationTime then
				return 0
			end
			return nil
		end
	end
	if type(SpellName) == "table" then
		local remaining = 0
		for _, v in ipairs(SpellName) do
			local result = CheckAura(v, unit, DurationRemainingGreaterThan, Stealable, Castable, SpellToolTipLineTwo, Type, owner, GiveExpirationTime, GiveApplications, Debuff)
			if result then
				if GiveApplications or GiveExpirationTime then
					if result > remaining then
						remaining = result
					end
				else
					return result
				end
			end
		end
		if GiveApplications or GiveExpirationTime then
			return remaining
		end
		return nil
	end
	local SpellName = s.SpellName(SpellName, 1)
	local d = "HELPFUL"
	local u = s.UnitSelection(unit)
	if Debuff then
		d = "HARMFUL"
	end
	if UnitExists(u) then
		local m = ""
		local o = owner
		if o and UnitIsUnit(o, "player") then
			m = "|PLAYER"
			o = nil
		end
		local c = ""
		if Castable then
			c = "|RAID"
		end
		local t = SpellToolTipLineTwo
		if SpellName and not t then
			local name, _, icon, count, debuffType, duration, expirationTime, unitCaster, isStealable = UnitAura(u, SpellName, nil, d..m..c)
			if name
			and ( not Type or Type:lower() == tostring(debuffType):lower() )
			and ( not Stealable or isStealable )
			and ( not GiveExpirationTime or expirationTime ~= 0 )
			and ( not o or ( type(unitCaster) == "string" and unitCaster ~= "" and UnitIsUnit(unitCaster, o) ) )
			and ( type(DurationRemainingGreaterThan) ~= "number" or DurationRemainingGreaterThan <= 0 or (expirationTime or 0) == 0 or expirationTime - GetTime() > DurationRemainingGreaterThan ) then
				if GiveApplications then
					if count == 0 then
						return 1
					end
					return count or 1
				elseif GiveExpirationTime then
					return expirationTime - GetTime()
				end
				return 1
			end
		elseif not SpellName or UnitAura(u, SpellName, nil, d..m..c) then
			local i = 1
			while UnitAura(u, i, d) do
				local name, _, icon, count, debuffType, duration, expirationTime, unitCaster, isStealable = UnitAura(u, i, d..m..c)
				if name
				and ( not SpellName or SpellName == name )
				and ( not Type or Type:lower() == tostring(debuffType):lower() )
				and ( not Stealable or isStealable )
				and ( not GiveExpirationTime or expirationTime ~= 0 )
				and ( not o or ( type(unitCaster) == "string" and unitCaster ~= "" and UnitIsUnit(unitCaster, o) ) )
				and ( type(DurationRemainingGreaterThan) ~= "number" or DurationRemainingGreaterThan <= 0 or (expirationTime or 0) == 0 or expirationTime - GetTime() > DurationRemainingGreaterThan ) then
					if t then
						SpellFlashAddon_Tooltip:ClearLines()
						SpellFlashAddon_Tooltip:SetUnitAura(u, i, d)
						if SpellFlashAddon_TooltipTextLeft2 and SpellFlashAddon_TooltipTextLeft2:GetObjectType() == "FontString" and SpellFlashAddon_TooltipTextLeft2:GetText():find(t, nil, true) then
							t = nil
						end
					end
					if not t then
						if GiveApplications then
							if count == 0 then
								return 1
							end
							return count or 1
						elseif GiveExpirationTime then
							return expirationTime - GetTime()
						end
						return 1
					end
				end
				i = i + 1
			end
		end
	end
	if GiveApplications or GiveExpirationTime then
		return 0
	end
	return nil
end

local function Hook_ActionButton_ShowOverlayGlow(self)
	if VARIABLES_CHECKED and SpellFlashAddonConfig.SERVER[SERVER].REALM[REALM].PLAYER[PLAYER].disable_default_proc_highlighting and self.overlay then
		self.overlay:Hide()
		ActionButton_HideOverlayGlow(self)
	end
end
hooksecurefunc("ActionButton_ShowOverlayGlow", Hook_ActionButton_ShowOverlayGlow)

-- This is used for testing purposes only
function SpellFlashAddon.ShowBuffs(unit, Debuff)
	local unit = unit
	if not unit then
		if UnitExists("target") then
			unit = "target"
		else
			unit = "player"
		end
	end
	local Debuff = Debuff
	local msg
	if Debuff then
		Debuff = "HARMFUL"
		msg = UnitName(unit).."'s Debuff Slot"
	else
		Debuff = "HELPFUL"
		msg = UnitName(unit).."'s Buff Slot"
	end
	local c = 1
	local name, _, icon, count, debuffType, duration, expirationTime, unitCaster, isStealable = UnitAura(unit, c, Debuff)
	if name then
		while name do
			local caster = ""
			if type(unitCaster) == "string" and unitCaster ~= "" and UnitExists(unitCaster) then
				caster = "     From: \""..unitCaster.."\" = "..UnitName(unitCaster)
			end
			print(msg.." "..c..": "..name..caster)
			c = c + 1
			name, _, icon, count, debuffType, duration, expirationTime, unitCaster, isStealable = UnitAura(unit, c, Debuff)
		end
	else
		print("All "..msg.."'s are empty.")
	end
end

-- This is used for testing purposes only
function SpellFlashAddon.ShowDebuffs(unit)
	SpellFlashAddon.ShowBuffs(unit, 1)
end

-- This is a test function
function SpellFlashAddon.ShowOffHandType()
	local Type = ItemSubType(GetInventoryItemID("player", GetInventorySlotInfo("SecondaryHandSlot")))
	if Type then
		Paste(Type, "Localized Off Hand Type")
	else
		message("You do not have an off hand item equipped.")
	end
end






function s.GetModuleConfig(AddonName, config)
	if VARIABLES_CHECKED and type(AddonName) == "string" and type(config) == "string" then
		if SpellFlashAddonConfig.SERVER[SERVER].REALM[REALM].PLAYER[PLAYER].MODULE[AddonName] then
			return SpellFlashAddonConfig.SERVER[SERVER].REALM[REALM].PLAYER[PLAYER].MODULE[AddonName][config]
		end
	end
	return nil
end

function s.SetModuleConfig(AddonName, config, value)
	if VARIABLES_CHECKED and type(AddonName) == "string" and type(config) == "string" then
		if value then
			if not SpellFlashAddonConfig.SERVER[SERVER].REALM[REALM].PLAYER[PLAYER].MODULE[AddonName] then
				SpellFlashAddonConfig.SERVER[SERVER].REALM[REALM].PLAYER[PLAYER].MODULE[AddonName] = {}
			end
			SpellFlashAddonConfig.SERVER[SERVER].REALM[REALM].PLAYER[PLAYER].MODULE[AddonName][config] = value
		elseif SpellFlashAddonConfig.SERVER[SERVER].REALM[REALM].PLAYER[PLAYER].MODULE[AddonName] then
			SpellFlashAddonConfig.SERVER[SERVER].REALM[REALM].PLAYER[PLAYER].MODULE[AddonName][config] = nil
		end
	end
end

function s.ClearAllModuleConfigs(AddonName)
	if VARIABLES_CHECKED and type(AddonName) == "string" then
		if SpellFlashAddonConfig.SERVER[SERVER].REALM[REALM].PLAYER[PLAYER].MODULE[AddonName] then
			wipe(SpellFlashAddonConfig.SERVER[SERVER].REALM[REALM].PLAYER[PLAYER].MODULE[AddonName])
		end
	end
end

function s.If(Argument, True, False)
	if Argument then
		return True
	end
	return False
end

function s.RegisterOtherAurasFunction(Function)
	if type(Function) == "function" then
		OtherAurasFunctions[Function] = true
	end
end

function s.SetOtherAuras(Spell, Aura, Delete)
	local Spell = s.SpellName(Spell, 1)
	if Spell then
		local Aura = s.SpellName(Aura, 1)
		if Aura then
			if Delete then
				if OtherAurasFromSpell[Spell] then
					OtherAurasFromSpell[Spell][Aura] = nil
					if next(OtherAurasFromSpell[Spell]) == nil then
						OtherAurasFromSpell[Spell] = nil
					end
				end
			else
				if not OtherAurasFromSpell[Spell] then
					OtherAurasFromSpell[Spell] = {}
				end
				OtherAurasFromSpell[Spell][Aura] = 1
			end
		end
	end
end

function s.AddSettingsListener(Function)
	if type(Function) == "function" then
		SettingsListenerFunctions[Function] = true
	end
end

function s.SpellDelay(SpellName)
	local count = 0
	if type(SpellName) == "table" then
		for _, value in ipairs(SpellName) do
			count = count + (s.SpellDelay(value) or 0)
		end
	else
		local SpellName = s.SpellName(SpellName, 1)
		if SpellName then
			if OtherAurasSpellFromAura[SpellName] then
				for spell in pairs(OtherAurasSpellFromAura[SpellName]) do
					if spell ~= SpellName then
						count = count + (SPELLDELAY[spell] or 0)
					end
				end
			end
			count = count + (SPELLDELAY[SpellName] or 0)
		end
	end
	if count > 0 then
		return count
	end
	return nil
end

function s.AuraDelay(SpellName, unit)
	if type(SpellName) == "table" then
		for _, value in ipairs(SpellName) do
			if s.AuraDelay(value, unit) then
				return 1
			end
		end
		return nil
	end
	local SpellName = s.SpellName(SpellName, 1)
	if SpellName and UnitExists(s.UnitSelection(unit)) and AddonTable:IsTimer(SpellName.."AuraDelay"..UnitGUID(s.UnitSelection(unit))) then
		return 1
	end
	return nil
end

function s.SpellOrAuraDelay(SpellName, unit)
	local count = (s.AuraDelay(SpellName, unit) or 0) + (s.SpellDelay(SpellName) or 0)
	if count > 0 then
		return count
	end
	return nil
end

local UnitTypesTable = {[0]="player", [3]="npc", [4]="pet", [5]="vehicle"}
local UnitIDPosition = {["player"]={6}, ["npc"]={7, 10}, ["pet"]={6, 12}, ["vehicle"]={7, 10}}
function s.GUIDInfo(GUID)
	if type(GUID) == "string" and GUID ~= "" then
		local Type = UnitTypesTable[tonumber(GUID:sub(5, 5), 16) % 8]
		if Type then
			local ID = tonumber(GUID:sub(unpack(UnitIDPosition[Type])), 16)
			return Type, ID
		end
		return "unknown"
	end
	return nil
end

function s.UnitInfo(unit)
	return s.GUIDInfo(UnitGUID(s.UnitSelection(unit)))
end

function s.UnitSelection(unit)
	if type(unit) == "string" then
		if unit:lower() == "enemy" then
			if IsModifiedClick("FOCUSCAST") then
				return "focus"
			end
			if s.Enemy("target") then
				return "target"
			end
			local u = "targettarget"
			local jumps = 1
			while UnitExists(u) do
				if s.Enemy(u) then
					return u
				end
				local t = "target"
				for _ = 1, jumps do
					if UnitIsUnit(u, t) then
						return "target"
					end
					t = t.."target"
				end
				jumps = jumps + 1
				u = u.."target"
			end
		else
			return unit
		end
	elseif IsModifiedClick("FOCUSCAST") then
		return "focus"
	end
	return "target"
end

function s.Form(form)
	local form = s.SpellName(form, 1)
	if form and CURRENTFORM then
		if form == CURRENTFORM or ALTERNATEFORM[form] == CURRENTFORM then
			return CURRENTFORM
		end
		return nil
	end
	return CURRENTFORM
end

function s.HasTalent(TalentName)
	local TalentName = s.SpellName(TalentName, 1)
	return TalentName and (TALENTRANK[TalentName] or 0) > 0
end

function s.TalentRank(TalentName)
	local TalentName = s.SpellName(TalentName, 1)
	if TalentName then
		return TALENTRANK[TalentName] or 0
	end
	return 0
end

-- this may be used to determine what talent tree has the most points in it
function s.TalentMastery(TreeTabNumber)
	if TreeTabNumber then
		if TreeTabNumber == ( TALENTMASTERY or 0 ) then
			return TALENTMASTERY or 0
		end
		return nil
	end
	return TALENTMASTERY
end

-- This also works for pet spells.
function s.HasSpell(SpellName)
	local SpellName = s.SpellName(SpellName)
	if SpellName then
		return SPELLS[SpellName] or PET_SPELLS[SpellName]
	end
	return nil
end

function s.HasItem(ItemName)
	local ItemName = s.ItemName(ItemName)
	return type(ItemName) == "string" and ItemName ~= "" and GetItemCount(ItemName) > 0
end


function s.SpellCooldown(SpellName)
	if SpellName then
		local start, duration = GetSpellCooldown(SpellName)
		local TimeLeft = (start or 0) + (duration or 0) - GetTime()
		if TimeLeft > 0 then
			return TimeLeft, duration
		end
	else
		return nil
	end
	return 0, 0
end

function s.ItemCooldown(ItemName)
	if ItemName then
		local ItemID = ItemName
		if type(ItemID) ~= "number" then
			ItemID = ItemIDFromItemName(ItemName)
		end
		if ItemID then
			local start, duration = GetItemCooldown(ItemID)
			local TimeLeft = (start or 0) + (duration or 0) - GetTime()
			if TimeLeft > 0 then
				return TimeLeft, duration
			end
		end
	end
	return 0, 0
end

function s.ActionCooldown(ActionID)
	if type(ActionID) == "number" then
		local start, duration = GetActionCooldown(ActionID)
		local TimeLeft = (start or 0) + (duration or 0) - GetTime()
		if TimeLeft > 0 then
			return TimeLeft, duration
		end
	else
		return nil
	end
	return 0, 0
end

function s.PetActionCooldown(PetActionID)
	if type(PetActionID) == "number" then
		local start, duration = GetPetActionCooldown(PetActionID)
		local TimeLeft = (start or 0) + (duration or 0) - GetTime()
		if TimeLeft > 0 then
			return TimeLeft, duration
		end
	else
		return nil
	end
	return 0, 0
end

function s.GlobalCooldown()
	return s.SpellCooldown(GLOBAL_COOLDOWN_SPELL)
end

function s.Autocast(SpellName)
	local SpellName = s.SpellName(SpellName)
	if SpellName then
		return not not ( select(2, GetSpellAutocast(SpellName)) )
	end
	return false
end

function s.CastTime(SpellName)
	if SpellName then
		return (select(7,GetSpellInfo(SpellName)) or 0) / 1000
	end
	return 0
end

function s.SpellCost(SpellName, PowerType)
	if SpellName then
		local name, rank, icon, cost, isFunnel, powerType = GetSpellInfo(SpellName)
		if not PowerType or PowerType == powerType then
			return cost or 0
		end
	end
	return 0
end


function s.HasGlyph(GlyphName)
	local GlyphName = s.SpellName(GlyphName, 1)
	if GlyphName then
		for i=1,GetNumGlyphSockets() do
			if s.SpellName((select(4, GetGlyphSocketInfo(i))), 1) == GlyphName then
				return true
			end
		end
	end
	return false
end

function s.MeleeDistance(unit)
	if s.HasSpell(MELEESPELL[CLASS]) then
		return s.SpellInRange(MELEESPELL[CLASS], unit)
	end
	return CheckInteractDistance(s.UnitSelection(unit), 3) and ( not OUTSIDEMELEESPELL or not s.SpellInRange(OUTSIDEMELEESPELL, unit) )
end


--Example: s.Class("target", "Death Knight")
--The example above will return true if your target is a Death Knight.
--This function has been made so that english class names must be used with this function even if you are not using an english game client.
--Spaces are allowed in the class name and the class name may also be in upper or lower case when using this function.
function s.Class(unit, class)
	local unit = s.UnitSelection(unit)
	if s.Player(unit) then
		local C = select(2, UnitClass(unit))
		if type(class) == "table" then
			for _, v in ipairs(class) do
				if tostring(v):upper():gsub("[^A-Z]", "") == C then
					return C
				end
			end
		elseif type(class) ~= "string" or class:upper():gsub("[^A-Z]", "") == C then
			return C
		end
	end
	return nil
end

--Example: s.Race("target", "Night Elf")
--The example above will return true if your target is a Night Elf.
--This function has been made so that english race names must be used with this function even if you are not using an english game client.
--Spaces are allowed in the race name and the race name may also be in upper or lower case when using this function.
function s.Race(unit, race)
	local unit = s.UnitSelection(unit)
	if s.Player(unit) then
		local R = select(2, UnitRace(unit)):upper():gsub("[^A-Z]", ""):gsub("^SCOURGE$", "UNDEAD")
		if type(race) == "table" then
			for _, v in ipairs(race) do
				if tostring(v):upper():gsub("[^A-Z]", ""):gsub("^SCOURGE$", "UNDEAD") == R then
					return R
				end
			end
		elseif type(race) ~= "string" or race:upper():gsub("[^A-Z]", ""):gsub("^SCOURGE$", "UNDEAD") == R then
			return R
		end
	end
	return nil
end

function s.SpellInRange(SpellName, unit)
	local unit = s.UnitSelection(unit)
	if type(SpellName) == "table" then
		for _, v in ipairs(SpellName) do
			if s.SpellInRange(v, unit) then
				return true
			end
		end
		return false
	end
	local SpellName = s.SpellName(SpellName)
	return SpellName and IsSpellInRange(SpellName, unit) == 1
end


function s.SpellHasRange(SpellName)
	if type(SpellName) == "table" then
		for _, v in ipairs(SpellName) do
			if s.SpellHasRange(v) then
				return true
			end
		end
		return false
	end
	local SpellName = s.SpellName(SpellName)
	return SpellName and SpellHasRange(SpellName)
end


function s.UsableSpell(SpellName)
	if type(SpellName) == "table" then
		for _, v in ipairs(SpellName) do
			if s.UsableSpell(v) then
				return true
			end
		end
		return false
	end
	return SpellName and IsUsableSpell(SpellName)
end


function s.CurrentSpell(SpellName)
	if type(SpellName) == "table" then
		for _, v in ipairs(SpellName) do
			if s.CurrentSpell(v) then
				return true
			end
		end
		return false
	end
	local SpellName = s.SpellName(SpellName)
	return SpellName and IsCurrentSpell(SpellName)
end

function s.Casting(SpellName, unit, interruptible, NoSubName)
	local name, subtext, text, texture, startTime, endTime, isTradeSkill, castID, notInterruptible = UnitCastingInfo(s.UnitSelection(unit))
	if name and ( not interruptible or not notInterruptible ) then
		if not SpellName then
			return (endTime / 1000) - GetTime()
		end
		if not NoSubName and subtext and subtext ~= "" then
			name = name.."("..subtext..")"
		end
		if type(SpellName) == "table" then
			for _, SpellName in ipairs(SpellName) do
				if ( s.SpellName(SpellName, NoSubName) or SpellName ) == name then
					return (endTime / 1000) - GetTime()
				end
			end
		elseif ( s.SpellName(SpellName, NoSubName) or SpellName ) == name then
			return (endTime / 1000) - GetTime()
		end
	end
	return nil
end

function s.Channeling(SpellName, unit, interruptible, NoSubName)
	local name, subtext, text, texture, startTime, endTime, isTradeSkill, notInterruptible = UnitChannelInfo(s.UnitSelection(unit))
	if name and ( not interruptible or not notInterruptible ) then
		if not SpellName then
			return (endTime / 1000) - GetTime()
		end
		if not NoSubName and subtext and subtext ~= "" then
			name = name.."("..subtext..")"
		end
		if type(SpellName) == "table" then
			for _, SpellName in ipairs(SpellName) do
				if ( s.SpellName(SpellName, NoSubName) or SpellName ) == name then
					return (endTime / 1000) - GetTime()
				end
			end
		elseif ( s.SpellName(SpellName, NoSubName) or SpellName ) == name then
			return (endTime / 1000) - GetTime()
		end
	end
	return nil
end

function s.CastingOrChanneling(SpellName, unit, interruptible, NoSubName)
	return s.Casting(SpellName, unit, interruptible, NoSubName) or s.Channeling(SpellName, unit, interruptible, NoSubName)
end

function s.GetCasting(SpellName, unit, interruptible, NoSubName)
	return s.Casting(SpellName, unit, interruptible, NoSubName) or 0
end

function s.GetChanneling(SpellName, unit, interruptible, NoSubName)
	return s.Channeling(SpellName, unit, interruptible, NoSubName) or 0
end

function s.GetCastingOrChanneling(SpellName, unit, interruptible, NoSubName)
	return s.CastingOrChanneling(SpellName, unit, interruptible, NoSubName) or 0
end

function s.CastingName(SpellName, unit, interruptible, NoSubName)
	local name, subtext, text, texture, startTime, endTime, isTradeSkill, castID, notInterruptible = UnitCastingInfo(s.UnitSelection(unit))
	if name and ( not interruptible or not notInterruptible ) then
		if not NoSubName and subtext and subtext ~= "" then
			name = name.."("..subtext..")"
		end
		if not SpellName then
			return name
		end
		if type(SpellName) == "table" then
			for _, SpellName in ipairs(SpellName) do
				if ( s.SpellName(SpellName, NoSubName) or SpellName ) == name then
					return name
				end
			end
		elseif ( s.SpellName(SpellName, NoSubName) or SpellName ) == name then
			return name
		end
	end
	return nil
end

function s.ChannelingName(SpellName, unit, interruptible, NoSubName)
	local name, subtext, text, texture, startTime, endTime, isTradeSkill, notInterruptible = UnitChannelInfo(s.UnitSelection(unit))
	if name and ( not interruptible or not notInterruptible ) then
		if not NoSubName and subtext and subtext ~= "" then
			name = name.."("..subtext..")"
		end
		if not SpellName then
			return name
		end
		if type(SpellName) == "table" then
			for _, SpellName in ipairs(SpellName) do
				if ( s.SpellName(SpellName, NoSubName) or SpellName ) == name then
					return name
				end
			end
		elseif ( s.SpellName(SpellName, NoSubName) or SpellName ) == name then
			return name
		end
	end
	return nil
end

function s.CastingOrChannelingName(SpellName, unit, interruptible, NoSubName)
	return s.CastingName(SpellName, unit, interruptible, NoSubName) or s.ChannelingName(SpellName, unit, interruptible, NoSubName)
end

function s.InCombat()
	return not not InCombatLockdown()
end

function s.Health(unit)
	return UnitHealth(s.UnitSelection(unit)) or 0
end

function s.MaxHealth(unit)
	return UnitHealthMax(s.UnitSelection(unit)) or 0
end

function s.HealthPercent(unit)
	if type(unit) == "string" then
		local group = "|"..unit.."|"
		if group:lower():match("|raid|") or group:lower():match("|party|") then
			local u = "player"
			local r = GetNumRaidMembers()
			local p = GetNumPartyMembers()
			local remaining = 0
			local counted = 0
			local result
			if not UnitIsDeadOrGhost(u) then
				if not group:lower():match("|notself|") and ( not group:lower():match("|healer|") or HEALERCLASS[CLASS] ) then
					result = ( s.Health(u) / s.MaxHealth(u) ) * 100
					if result < 90 or not group:lower():match("|notfull|") then
						counted = 1
						remaining = result
					end
				end
				if group:lower():match("|raid|") and r > 1 then
					for i = 1, r do
						u = "raid"..i
						if not UnitIsUnit(u, "player") and UnitIsVisible(u) and UnitIsConnected(u) and not UnitIsDeadOrGhost(u) and ( not group:lower():match("|afk|") or not UnitIsAFK(u) ) and ( not group:lower():match("|range|") or UnitInRange(u) ) and ( not group:lower():match("|healer|") or HEALERCLASS[s.Class(u)] ) then
							result = ( s.Health(u) / s.MaxHealth(u) ) * 100
							if result < 90 or not group:lower():match("|notfull|") then
								counted = counted + 1
								if group:lower():match("|average|") then
									remaining = remaining + result
								elseif remaining == 0 or result < remaining then
									remaining = result
								end
							end
						end
					end
				elseif p > 0 then
					for i = 1, p do
						u = "party"..i
						if UnitIsVisible(u) and UnitIsConnected(u) and not UnitIsDeadOrGhost(u) and ( not group:lower():match("|afk|") or not UnitIsAFK(u) ) and ( not group:lower():match("|range|") or UnitInRange(u) ) and ( not group:lower():match("|healer|") or HEALERCLASS[s.Class(u)] ) then
							result = ( s.Health(u) / s.MaxHealth(u) ) * 100
							if result < 90 or not group:lower():match("|notfull|") then
								counted = counted + 1
								if group:lower():match("|average|") then
									remaining = remaining + result
								elseif remaining == 0 or result < remaining then
									remaining = result
								end
							end
						end
					end
				end
			end
			if counted > 1 and group:lower():match("|average|") then
				return ( remaining / counted ), counted
			end
			return remaining, counted
		end
	end
	return ( s.Health(unit) / s.MaxHealth(unit) ) * 100
end

function s.HealthDamage(unit)
	return s.MaxHealth(unit) - s.Health(unit)
end

function s.HealthDamagePercent(unit)
	local remaining, counted = s.HealthPercent(unit)
	if counted then
		return ( 100 - remaining ), counted
	end
	return 100 - remaining
end

function s.Power(unit, PowerType)
	return UnitPower(s.UnitSelection(unit), PowerType) or 0
end

function s.MaxPower(unit, PowerType)
	return UnitPowerMax(s.UnitSelection(unit), PowerType) or 0
end

function s.PowerPercent(unit, PowerType)
	if type(unit) == "string" then
		local group = "|"..unit.."|"
		if group:lower():match("|raid|") or group:lower():match("|party|") then
			local u = "player"
			local r = GetNumRaidMembers()
			local p = GetNumPartyMembers()
			local remaining = 0
			local counted = 0
			local result
			if not UnitIsDeadOrGhost(u) then
				if not group:lower():match("|notself|") and ( not group:lower():match("|healer|") or HEALERCLASS[CLASS] ) then
					result = ( s.Power(u, PowerType) / s.MaxPower(u, PowerType) ) * 100
					if result < 90 or not group:lower():match("|notfull|") then
						counted = 1
						remaining = result
					end
				end
				if group:lower():match("|raid|") and r > 1 then
					for i = 1, r do
						u = "raid"..i
						if not UnitIsUnit(u, "player") and UnitIsVisible(u) and UnitIsConnected(u) and not UnitIsDeadOrGhost(u) and ( not group:lower():match("|afk|") or not UnitIsAFK(u) ) and ( not group:lower():match("|range|") or UnitInRange(u) ) and ( not group:lower():match("|healer|") or HEALERCLASS[s.Class(u)] ) then
							result = ( s.Power(u, PowerType) / s.MaxPower(u, PowerType) ) * 100
							if result < 90 or not group:lower():match("|notfull|") then
								counted = counted + 1
								if group:lower():match("|average|") then
									remaining = remaining + result
								elseif remaining == 0 or result < remaining then
									remaining = result
								end
							end
						end
					end
				elseif p > 0 then
					for i = 1, p do
						u = "party"..i
						if UnitIsVisible(u) and UnitIsConnected(u) and not UnitIsDeadOrGhost(u) and ( not group:lower():match("|afk|") or not UnitIsAFK(u) ) and ( not group:lower():match("|range|") or UnitInRange(u) ) and ( not group:lower():match("|healer|") or HEALERCLASS[s.Class(u)] ) then
							result = ( s.Power(u, PowerType) / s.MaxPower(u, PowerType) ) * 100
							if result < 90 or not group:lower():match("|notfull|") then
								counted = counted + 1
								if group:lower():match("|average|") then
									remaining = remaining + result
								elseif remaining == 0 or result < remaining then
									remaining = result
								end
							end
						end
					end
				end
			end
			if counted > 1 and group:lower():match("|average|") then
				return ( remaining / counted ), counted
			end
			return remaining, counted
		end
	end
	return ( s.Power(unit, PowerType) / s.MaxPower(unit, PowerType) ) * 100
end

function s.PowerMissing(unit, PowerType)
	return s.MaxPower(unit, PowerType) - s.Power(unit, PowerType)
end

function s.PowerMissingPercent(unit, PowerType)
	local remaining, counted = s.PowerPercent(unit, PowerType)
	if counted then
		return ( 100 - remaining ), counted
	end
	return 100 - remaining
end

function s.UsesMana(unit)
	return UnitPowerType(s.UnitSelection(unit)) == SPELL_POWER_MANA or UnitPowerMax(s.UnitSelection(unit), SPELL_POWER_MANA) > 0
end

function s.HasMana(unit)
	return UnitPower(s.UnitSelection(unit), SPELL_POWER_MANA) > 0
end



function s.Healer(unit)
	if type(unit) == "string" then
		local group = "|"..unit.."|"
		if group:lower():match("|raid|") or group:lower():match("|party|") then
			local u = "player"
			local r = GetNumRaidMembers()
			local p = GetNumPartyMembers()
			if not UnitIsDeadOrGhost(u) then
				if not group:lower():match("|notself|") then
					if HEALERCLASS[CLASS] then
						return u
					end
				end
				if group:lower():match("|raid|") and r > 1 then
					for i = 1, r do
						u = "raid"..i
						if not UnitIsUnit(u, "player") and UnitIsVisible(u) and UnitIsConnected(u) and not UnitIsDeadOrGhost(u) and ( not group:lower():match("|afk|") or not UnitIsAFK(u) ) and ( not group:lower():match("|range|") or UnitInRange(u) ) and HEALERCLASS[s.Class(u)] then
							return u
						end
					end
				elseif p > 0 then
					for i = 1, p do
						u = "party"..i
						if UnitIsVisible(u) and UnitIsConnected(u) and not UnitIsDeadOrGhost(u) and ( not group:lower():match("|afk|") or not UnitIsAFK(u) ) and ( not group:lower():match("|range|") or UnitInRange(u) ) and HEALERCLASS[s.Class(u)] then
							return u
						end
					end
				end
			end
			return nil
		end
	end
	local u = s.UnitSelection(unit)
	if UnitIsUnit(u, "player") then
		if not UnitIsDeadOrGhost(u) and HEALERCLASS[CLASS] then
			return u
		end
	elseif s.Player(u) and UnitIsVisible(u) and UnitIsConnected(u) and not UnitIsDeadOrGhost(u) and HEALERCLASS[s.Class(u)] then
		return u
	end
	return nil
end


--returns true if all of the debuff slots are used
function s.AllDebuffSlotsUsed(unit)
	return not not UnitAura(s.UnitSelection(unit), MAXDEBUFFSLOTS, "HARMFUL")
end

function s.Buff(SpellName, unit, DurationRemainingGreaterThan, Stealable, Castable, SpellToolTipLineTwo)
	return CheckAura(SpellName, unit, DurationRemainingGreaterThan, Stealable, Castable, SpellToolTipLineTwo)
end

function s.BuffStack(SpellName, unit, DurationRemainingGreaterThan, Stealable, Castable, SpellToolTipLineTwo)
	return CheckAura(SpellName, unit, DurationRemainingGreaterThan, Stealable, Castable, SpellToolTipLineTwo, nil, nil, nil, 1)
end

function s.BuffDuration(SpellName, unit, DurationRemainingGreaterThan, Stealable, Castable, SpellToolTipLineTwo)
	return CheckAura(SpellName, unit, DurationRemainingGreaterThan, Stealable, Castable, SpellToolTipLineTwo, nil, nil, 1)
end

function s.MyBuff(SpellName, unit, DurationRemainingGreaterThan, Stealable, Castable, SpellToolTipLineTwo)
	return CheckAura(SpellName, unit, DurationRemainingGreaterThan, Stealable, Castable, SpellToolTipLineTwo, nil, "player")
end

function s.MyBuffStack(SpellName, unit, DurationRemainingGreaterThan, Stealable, Castable, SpellToolTipLineTwo)
	return CheckAura(SpellName, unit, DurationRemainingGreaterThan, Stealable, Castable, SpellToolTipLineTwo, nil, "player", nil, 1)
end

function s.MyBuffDuration(SpellName, unit, DurationRemainingGreaterThan, Stealable, Castable, SpellToolTipLineTwo)
	return CheckAura(SpellName, unit, DurationRemainingGreaterThan, Stealable, Castable, SpellToolTipLineTwo, nil, "player", 1)
end

function s.SelfBuff(SpellName, unit, DurationRemainingGreaterThan, Stealable, Castable, SpellToolTipLineTwo)
	local unit = s.UnitSelection(unit)
	return CheckAura(SpellName, unit, DurationRemainingGreaterThan, Stealable, Castable, SpellToolTipLineTwo, nil, unit)
end

function s.Debuff(SpellName, unit, DurationRemainingGreaterThan, Stealable, Dispelable, SpellToolTipLineTwo, Type)
	return CheckAura(SpellName, unit, DurationRemainingGreaterThan, Stealable, Dispelable, SpellToolTipLineTwo, Type, nil, nil, nil, 1)
end

function s.DebuffStack(SpellName, unit, DurationRemainingGreaterThan, Stealable, Dispelable, SpellToolTipLineTwo, Type)
	return CheckAura(SpellName, unit, DurationRemainingGreaterThan, Stealable, Dispelable, SpellToolTipLineTwo, Type, nil, nil, 1, 1)
end

function s.DebuffDuration(SpellName, unit, DurationRemainingGreaterThan, Stealable, Dispelable, SpellToolTipLineTwo, Type)
	return CheckAura(SpellName, unit, DurationRemainingGreaterThan, Stealable, Dispelable, SpellToolTipLineTwo, Type, nil, 1, nil, 1)
end

function s.MyDebuff(SpellName, unit, DurationRemainingGreaterThan, Stealable, Dispelable, SpellToolTipLineTwo, Type)
	return CheckAura(SpellName, unit, DurationRemainingGreaterThan, Stealable, Dispelable, SpellToolTipLineTwo, Type, "player", nil, nil, 1)
end

function s.MyDebuffStack(SpellName, unit, DurationRemainingGreaterThan, Stealable, Dispelable, SpellToolTipLineTwo, Type)
	return CheckAura(SpellName, unit, DurationRemainingGreaterThan, Stealable, Dispelable, SpellToolTipLineTwo, Type, "player", nil, 1, 1)
end

function s.MyDebuffDuration(SpellName, unit, DurationRemainingGreaterThan, Stealable, Dispelable, SpellToolTipLineTwo, Type)
	return CheckAura(SpellName, unit, DurationRemainingGreaterThan, Stealable, Dispelable, SpellToolTipLineTwo, Type, "player", 1, nil, 1)
end


function s.MainHandItemBuff(SpellName, DurationRemainingGreaterThan)
	return CheckAura(SpellName, "MainHandSlot", DurationRemainingGreaterThan)
end

function s.MainHandItemBuffStack(SpellName, DurationRemainingGreaterThan)
	return CheckAura(SpellName, "MainHandSlot", DurationRemainingGreaterThan, nil, nil, nil, nil, nil, nil, 1)
end

function s.MainHandItemBuffDuration(SpellName, DurationRemainingGreaterThan)
	return CheckAura(SpellName, "MainHandSlot", DurationRemainingGreaterThan, nil, nil, nil, nil, nil, 1)
end

function s.OffHandItemBuff(SpellName, DurationRemainingGreaterThan)
	return CheckAura(SpellName, "SecondaryHandSlot", DurationRemainingGreaterThan)
end

function s.OffHandItemBuffStack(SpellName, DurationRemainingGreaterThan)
	return CheckAura(SpellName, "SecondaryHandSlot", DurationRemainingGreaterThan, nil, nil, nil, nil, nil, nil, 1)
end

function s.OffHandItemBuffDuration(SpellName, DurationRemainingGreaterThan)
	return CheckAura(SpellName, "SecondaryHandSlot", DurationRemainingGreaterThan, nil, nil, nil, nil, nil, 1)
end

function s.RangedItemBuff(SpellName, DurationRemainingGreaterThan)
	return CheckAura(SpellName, "RangedSlot", DurationRemainingGreaterThan)
end

function s.RangedItemBuffStack(SpellName, DurationRemainingGreaterThan)
	return CheckAura(SpellName, "RangedSlot", DurationRemainingGreaterThan, nil, nil, nil, nil, nil, nil, 1)
end

function s.RangedItemBuffDuration(SpellName, DurationRemainingGreaterThan)
	return CheckAura(SpellName, "RangedSlot", DurationRemainingGreaterThan, nil, nil, nil, nil, nil, 1)
end


function s.Enemy(unit)
	local unit = s.UnitSelection(unit)
	return UnitExists(unit) and UnitCanAttack("player", unit) and ( not UnitIsDeadOrGhost(unit) or UnitAffectingCombat(unit) or UnitExists(unit.."target") )
end

function s.ActiveEnemy(unit, NoCrowedControlCheck)
	local unit = s.UnitSelection(unit)
	return s.Enemy(unit) and ( UnitAffectingCombat(unit) or s.Player(unit) or UnitIsDummy(unit) ) and not UnitIsDeadOrGhost(unit) and ( NoCrowedControlCheck or not s.NoDamageCC(unit) )
end

function s.GivesXP(unit)
	local unit = s.UnitSelection(unit)
	return s.Enemy(unit) and not UnitIsTrivial(unit) and UnitFactionGroup(unit) ~= UnitFactionGroup("player") and ( not UnitPlayerControlled(unit) or s.Player(unit) ) and ( s.Player(unit) or not UnitIsTapped(unit) or UnitIsTappedByPlayer(unit) or UnitIsTappedByAllThreatList(unit) )
end

function s.NotDieing(unit)
	local unit = s.UnitSelection(unit)
	return UnitExists(unit) and ( not UnitIsDeadOrGhost(unit) or UnitAffectingCombat(unit) or UnitExists(unit.."target") ) and ( s.HealthPercent(unit) > 25 or s.Player(unit) or s.Boss(unit) )
end

function s.Player(unit)
	return UnitIsPlayer(s.UnitSelection(unit))
end

function s.Boss(unit)
	local unit = s.UnitSelection(unit)
	return UnitExists(unit) and not UnitPlayerControlled(unit) and ( tostring(UnitClassification(unit)):lower():match("boss") or UnitLevel(unit) == -1 or UnitIsBossUnit(unit) )
end

function s.EnemyTargetingYourFriend(unit)
	local unit = s.UnitSelection(unit)
	return s.Enemy(unit) and not UnitIsUnit(unit.."target", "player") and UnitIsFriend("player", unit.."target")
end

function s.EnemyTargetingYou(unit)
	local unit = s.UnitSelection(unit)
	return s.Enemy(unit) and UnitIsUnit(unit.."target", "player")
end

function s.SameTargetAsPet(unit)
	local unit = s.UnitSelection(unit)
	return UnitExists("pettarget") and UnitIsUnit(unit, "pettarget")
end


-- 15590--[[Fist Weapons]]
-- 227--[[Staves]]
-- 200--[[Polearms]]
-- 198--[[One-Handed Maces]]
-- 199--[[Two-Handed Maces]]
-- 196--[[One-Handed Axes]]
-- 197--[[Two-Handed Axes]]
-- 201--[[One-Handed Swords]]
-- 202--[[Two-Handed Swords]]
-- 1180--[[Daggers]]

-- checks to see if a fist weapon is equipped in the main hand
function s.MainHand(ItemType)
	if type(ItemType) == "table" then
		for _, v in ipairs(ItemType) do
			local result = s.MainHand(v)
			if result then
				return result
			end
		end
	else
		local ItemType = ItemType
		if type(ItemType) == "number" then
			ItemType = s.SpellName(ItemType, 1)
			if not ItemType then
				return nil
			end
		end
		local slot = GetInventorySlotInfo("MainHandSlot")
		local Type = ItemSubType(GetInventoryItemID("player", slot))
		if Type and not GetInventoryItemBroken("player", slot) and ( not ItemType or Type == ItemType ) then
			return Type
		end
	end
	return nil
end

-- checks to see if a fist weapon is equipped in the main hand
function s.OffHand(ItemType)
	if type(ItemType) == "table" then
		for _, v in ipairs(ItemType) do
			local result = s.MainHand(v)
			if result then
				return result
			end
		end
	else
		local ItemType = ItemType
		if type(ItemType) == "number" then
			ItemType = s.SpellName(ItemType, 1)
			if not ItemType then
				return nil
			end
		end
		local slot = GetInventorySlotInfo("SecondaryHandSlot")
		local Type = ItemSubType(GetInventoryItemID("player", slot))
		if Type and not GetInventoryItemBroken("player", slot) and ( not ItemType or Type == ItemType ) then
			return Type
		end
	end
	return nil
end


-- checks to see if a shield is equipped
function s.ShieldEquipped()
	return s.OffHand(L["Shields"])
end


function s.Equipped(ItemName, Slot)
	if type(ItemName) == "table" then
		for _, v in ipairs(ItemName) do
			local result = s.Equipped(v, Slot)
			if result then
				return result
			end
		end
	elseif Slot then
		local Slot = Slot
		if type(Slot) == "string" then
			Slot = GetInventorySlotInfo(Slot)
		end
		if type(Slot) == "number" then
			local ID = GetInventoryItemID("player", Slot)
			if ID and not GetInventoryItemBroken("player", Slot) and ( not ItemName or ItemName == ID or ( type(ItemName) == "string" and ItemName == s.ItemName(ID) ) ) then
				return Slot
			end
		end
	elseif ItemName then
		for i = 0, 19 do
			local ID = GetInventoryItemID("player", i)
			if ID and not GetInventoryItemBroken("player", i) and ( ItemName == ID or ( type(ItemName) == "string" and ItemName == s.ItemName(ID) ) ) then
				return i
			end
		end
	end
	return nil
end


function s.Shooting()
	return not not SHOOT
end

function s.PetCastable(SpellName, PetFrameNeeded, PetHealthNotNeeded, GlobalPetCooldownSpell, EvenIfNotUsable)
	local unit
	if UnitExists("pettarget") then
		unit = "pettarget"
	else
		unit = s.UnitSelection()
	end
	if Immune(SpellName, unit) then
		return false
	end
	local SpellName = s.SpellName(SpellName)
	if type(SpellName) == "string" and SpellName ~= "" and ( AddonTable.PetActions[SpellName] or s.HasSpell(SpellName) ) and not s.CastingOrChanneling(SpellName, "pet") and ( PetHealthNotNeeded or UnitHealth("pet") > 0 ) and ( not PetFrameNeeded or UnitExists("pet") ) then
		for n = 1, NUM_PET_ACTION_SLOTS do
			local name, subtext, texture, isToken, isActive = GetPetActionInfo(n)
			if subtext and subtext ~= "" then
				name = name.."("..subtext..")"
			end
			if ( AddonTable.PetActions[SpellName] or SpellName ) == name then
				local globalcooldown = nil
				local GlobalCooldownSpell = s.SpellName(GlobalPetCooldownSpell)
				if s.HasSpell(GlobalCooldownSpell) then
					globalcooldown = s.SpellCooldown(GlobalCooldownSpell)
				end
				local Lag = select(3, GetNetStats()) / 1000
				local cooldown, duration = s.PetActionCooldown(n)
				return not isActive and ( EvenIfNotUsable or GetPetActionSlotUsable(n) ) and ( duration <= 1.5 or cooldown <= Lag or ( globalcooldown and cooldown <= 1.5 and cooldown <= globalcooldown ) )
			end
		end
	end
	return false
end


local AuraFunctions = {
	MyDebuff = s.MyDebuff,
	MyBuff = s.MyBuff,
	Debuff = s.Debuff,
	Buff = s.Buff,
}
local AuraStackFunctions = {
	MyDebuff = s.MyDebuffStack,
	MyBuff = s.MyBuffStack,
	Debuff = s.DebuffStack,
	Buff = s.BuffStack,
}

function s.Castable(z)
	if type(z.Override) == "function" then
		return z:Override()
	elseif type(z.Run) == "function" then
		z:Run()
	end
	if type(z.CheckFirst) == "function" and not z:CheckFirst() then
		return false
	elseif z.Type == "item" then
		return s.CheckIfItemCastable(z) and ( type(z.CheckLast) ~= "function" or z:CheckLast() )
	elseif z.Type == "pet" then
		return s.CheckIfPetSpellCastable(z) and ( type(z.CheckLast) ~= "function" or z:CheckLast() )
	elseif z.Type == "vehicle" then
		return s.CheckIfVehicleSpellCastable(z) and ( type(z.CheckLast) ~= "function" or z:CheckLast() )
	end
	return s.CheckIfSpellCastable(z) and ( type(z.CheckLast) ~= "function" or z:CheckLast() )
end

function s.CheckIfSpellCastable(z)
	if not z.ID then
		z.ID = z.SpellID
	end
	if z.Type == "form" and s.Form(z.ID) then
		return false
	end
	if type(z.Name) ~= "string" then
		z.Name = s.SpellName(z.ID)
	end
	if type(z.Name) ~= "string" or not s.HasSpell(z.Name) then
		return false
	end
	z.Unit = s.UnitSelection(z.Unit)
	if z.EnemyTargetNeeded and Immune(z.ID, z.Unit) then
		return false
	end
	local Lag = select(3, GetNetStats()) / 1000
	local DoubleLag = Lag * 2
	local CastingTimeLeft = s.GetCasting(nil, "player")
	local CastingOrChanneling = s.CastingOrChanneling(z.Name, "player")
	local Current = s.CurrentSpell(z.Name)
	local globalcooldown = 0
	if not z.NoGCD then
		globalcooldown = s.GlobalCooldown()
	end
	local cooldown, duration = s.SpellCooldown(z.ID)
	local name, rank, icon, cost, isFunnel, powerType, castTime = GetSpellInfo(z.ID)
	z.CastTime = z.CastTime or ((castTime or 0) / 1000)
	local i = ""
	if not z["Buff"] and not z["Debuff"] and not z["MyBuff"] and not z["MyDebuff"] then
		i = 1
	end
	while z["Buff"..i] or z["Debuff"..i] or z["MyBuff"..i] or z["MyDebuff"..i] do
		for Aura in pairs(AuraFunctions) do
			if z[Aura..i] then
				if (z["Stack"..i] or 0) < 1 then
					z["Stack"..i] = 1
				end
				local CastingQueued = 0
				if Current or CastingOrChanneling then
					CastingQueued = 1
				end
				local Function = AuraStackFunctions[Aura]
				if z["Stack"..i] == 1 then
					if CastingQueued == 1 then
						return false
					end
					Function = AuraFunctions[Aura]
				end
				if CastingQueued == 0 then
					local AuraName = s.SpellName(z[Aura..i], 1)
					if AuraName and OtherAurasSpellFromAura[AuraName] then
						for spell in pairs(OtherAurasSpellFromAura[AuraName]) do
							if s.CurrentSpell(spell) or s.CastingOrChanneling(spell, "player", nil, 1) then
								if z["Stack"..i] == 1 then
									return false
								end
								CastingQueued = 1
								break
							end
						end
					end
				end
				if (Function(z[Aura..i], z["BuffUnit"..i] or z.Unit, z.CastTime + math.max(CastingTimeLeft, cooldown) + DoubleLag + (z["EarlyRefresh"..i] or 0)) or 0) + (s.SpellOrAuraDelay(z[Aura..i], z.Unit) or 0) + CastingQueued >= z["Stack"..i] then
					return false
				end
			end
		end
		i = ( tonumber(i) or 0 ) + 1
	end
	i = ""
	if not z["RequireBuff"] and not z["RequireDebuff"] and not z["RequireMyBuff"] and not z["RequireMyDebuff"] then
		i = 1
	end
	while z["RequireBuff"..i] or z["RequireDebuff"..i] or z["RequireMyBuff"..i] or z["RequireMyDebuff"..i] do
		for Aura in pairs(AuraFunctions) do
			if z["Require"..Aura..i] then
				if (z["RequireStack"..i] or 0) < 1 then
					z["RequireStack"..i] = 1
				end
				local Function = AuraStackFunctions[Aura]
				if z["RequireStack"..i] == 1 then
					Function = AuraFunctions[Aura]
				end
				if (Function(z["Require"..Aura..i], z["RequireBuffUnit"..i] or z.Unit, math.max(CastingTimeLeft, cooldown) + DoubleLag + (z["RequireMoreBuffTime"..i] or 0)) or 0) < z["RequireStack"..i] then
					return false
				end
			end
		end
		i = ( tonumber(i) or 0 ) + 1
	end
	local isUsable, notEnoughPower = s.UsableSpell(z.ID)
	local SpellCastPower = s.SpellCost(s.CastingName(nil, "player"), powerType)
	return ( z.EvenIfNotUsable or isUsable ) and ( z.NoPowerCheck or not notEnoughPower )
		and ( not z.Melee or s.MeleeDistance(z.Unit) )
		and ( z.NoPowerCheck or SpellCastPower == 0 or UnitPower("player", powerType) >= (cost or 0) + SpellCastPower )
		and ( SUPPRESS_SPEED_CHECK or not z.NotWhileMoving or GetUnitSpeed("player") == 0 )
		and ( cooldown <= Lag + CastingTimeLeft or ( not globalcooldown and duration <= 1.5 ) or ( globalcooldown and cooldown <= globalcooldown ) )
		and ( not z.NotIfActive or ( not Current and not CastingOrChanneling ) or ( CastingOrChanneling and CastingOrChanneling <= Lag ) )
		and ( SUPPRESS_RANGE_CHECK or z.NoRangeCheck or UnitIsUnit(z.Unit, "player") or UnitIsUnit(z.Unit, "vehicle") or not s.SpellHasRange(z.Name) or s.SpellInRange(z.Name, z.Unit) )
		and ( not z.EnemyTargetNeeded or s.Enemy(z.Unit) )
		and ( not z.TargetThatUsesManaNeeded or s.UsesMana(z.Unit) )
		and ( not z.DebuffSlotNeeded or not s.AllDebuffSlotsUsed(z.Unit) )
		and ( not z.Interrupt or s.GetCastingOrChanneling(nil, z.Unit, 1) > (CastingOrChanneling or (cooldown + z.CastTime)) + DoubleLag )
end


function s.CheckIfItemCastable(z)
	if not z.ID then
		z.ID = z.ItemID
	end
	if type(z.Name) ~= "string" then
		z.Name = s.ItemName(z.ID)
	end
	if type(z.Name) ~= "string" or not s.HasItem(z.Name) then
		return false
	end
	z.Unit = s.UnitSelection(z.Unit)
	if z.EnemyTargetNeeded and Immune(z.Name, z.Unit) then
		return false
	end
	local Lag = select(3, GetNetStats()) / 1000
	local DoubleLag = Lag * 2
	local CastingTimeLeft = s.GetCasting(nil, "player")
	local CastingOrChanneling = s.CastingOrChanneling(z.Name, "player")
	local Current = IsCurrentItem(z.ID)
	local globalcooldown = 0
	if not z.NoGCD then
		globalcooldown = s.GlobalCooldown()
	end
	local cooldown, duration = s.ItemCooldown(z.ID)
	z.CastTime = z.CastTime or 0
	local i = ""
	if not z["Buff"] and not z["Debuff"] and not z["MyBuff"] and not z["MyDebuff"] then
		i = 1
	end
	while z["Buff"..i] or z["Debuff"..i] or z["MyBuff"..i] or z["MyDebuff"..i] do
		for Aura in pairs(AuraFunctions) do
			if z[Aura..i] then
				if (z["Stack"..i] or 0) < 1 then
					z["Stack"..i] = 1
				end
				local CastingQueued = 0
				if Current or CastingOrChanneling then
					CastingQueued = 1
				end
				local Function = AuraStackFunctions[Aura]
				if z["Stack"..i] == 1 then
					if CastingQueued == 1 then
						return false
					end
					Function = AuraFunctions[Aura]
				end
				if (Function(z[Aura..i], z["BuffUnit"..i] or z.Unit, z.CastTime + math.max(CastingTimeLeft, cooldown) + DoubleLag + (z["EarlyRefresh"..i] or 0)) or 0) + (s.SpellOrAuraDelay(z[Aura..i], z.Unit) or 0) + CastingQueued >= z["Stack"..i] then
					return false
				end
			end
		end
		i = ( tonumber(i) or 0 ) + 1
	end
	i = ""
	if not z["RequireBuff"] and not z["RequireDebuff"] and not z["RequireMyBuff"] and not z["RequireMyDebuff"] then
		i = 1
	end
	while z["RequireBuff"..i] or z["RequireDebuff"..i] or z["RequireMyBuff"..i] or z["RequireMyDebuff"..i] do
		for Aura in pairs(AuraFunctions) do
			if z["Require"..Aura..i] then
				if (z["RequireStack"..i] or 0) < 1 then
					z["RequireStack"..i] = 1
				end
				local Function = AuraStackFunctions[Aura]
				if z["RequireStack"..i] == 1 then
					Function = AuraFunctions[Aura]
				end
				if (Function(z["Require"..Aura..i], z["RequireBuffUnit"..i] or z.Unit, math.max(CastingTimeLeft, cooldown) + DoubleLag + (z["RequireMoreBuffTime"..i] or 0)) or 0) < z["RequireStack"..i] then
					return false
				end
			end
		end
		i = ( tonumber(i) or 0 ) + 1
	end
	local isUsable, notEnoughPower = IsUsableItem(z.ID)
	return ( z.EvenIfNotUsable or isUsable ) and ( z.NoPowerCheck or not notEnoughPower )
		and ( not z.Melee or s.MeleeDistance(z.Unit) )
		and ( z.NoEquipCheck or not IsEquippableItem(z.ID) or IsEquippedItem(z.ID) )
		and ( SUPPRESS_SPEED_CHECK or not z.NotWhileMoving or GetUnitSpeed("player") == 0 )
		and ( cooldown <= Lag + CastingTimeLeft or ( not globalcooldown and duration <= 1.5 ) or ( globalcooldown and cooldown <= globalcooldown ) )
		and ( not z.NotIfActive or ( not Current and not CastingOrChanneling ) or ( CastingOrChanneling and CastingOrChanneling <= Lag ) )
		and ( SUPPRESS_RANGE_CHECK or z.NoRangeCheck or UnitIsUnit(z.Unit, "player") or UnitIsUnit(z.Unit, "vehicle") or not ItemHasRange(z.ID) or IsItemInRange(z.ID, z.Unit) == 1 )
		and ( not z.EnemyTargetNeeded or s.Enemy(z.Unit) )
		and ( not z.TargetThatUsesManaNeeded or s.UsesMana(z.Unit) )
		and ( not z.DebuffSlotNeeded or not s.AllDebuffSlotsUsed(z.Unit) )
		and ( not z.Interrupt or s.GetCastingOrChanneling(nil, z.Unit, 1) > (CastingOrChanneling or (cooldown + z.CastTime)) + DoubleLag )
end


function s.CheckIfVehicleSpellCastable(z)
	if not z.ID then
		z.ID = z.SpellID
	end
	if not UnitInVehicle("player") then return false end
	if type(z.Name) ~= "string" then
		z.Name = s.SpellName(z.ID)
	end
	if type(z.Name) ~= "string" then
		return false
	end
	z.Unit = s.UnitSelection(z.Unit)
	if z.EnemyTargetNeeded and Immune(z.ID, z.Unit) then
		return false
	end
	local slot = VehicleSlot(z.Name)
	if not slot then
		return false
	end
	local Lag = select(3, GetNetStats()) / 1000
	local DoubleLag = Lag * 2
	local CastingTimeLeft = s.GetCasting(nil, "vehicle")
	local CastingOrChanneling = s.CastingOrChanneling(z.Name, "vehicle")
	local Current = IsCurrentAction(slot)
	local globalcooldown = 0
	if not z.NoGCD then
		globalcooldown = s.ActionCooldown(VehicleSlot(z.GlobalVehicleCooldownSpell))
	end
	local cooldown, duration = s.ActionCooldown(slot)
	z.CastTime = z.CastTime or 0
	local i = ""
	if not z["Buff"] and not z["Debuff"] and not z["MyBuff"] and not z["MyDebuff"] then
		i = 1
	end
	while z["Buff"..i] or z["Debuff"..i] or z["MyBuff"..i] or z["MyDebuff"..i] do
		for Aura in pairs(AuraFunctions) do
			if z[Aura..i] then
				if (z["Stack"..i] or 0) < 1 then
					z["Stack"..i] = 1
				end
				local CastingQueued = 0
				if Current or CastingOrChanneling then
					CastingQueued = 1
				end
				local Function = AuraStackFunctions[Aura]
				if z["Stack"..i] == 1 then
					if CastingQueued == 1 then
						return false
					end
					Function = AuraFunctions[Aura]
				end
				if (Function(z[Aura..i], z["BuffUnit"..i] or z.Unit, z.CastTime + math.max(CastingTimeLeft, cooldown) + DoubleLag + (z["EarlyRefresh"..i] or 0)) or 0) + (s.SpellOrAuraDelay(z[Aura..i], z.Unit) or 0) + CastingQueued >= z["Stack"..i] then
					return false
				end
			end
		end
		i = ( tonumber(i) or 0 ) + 1
	end
	i = ""
	if not z["RequireBuff"] and not z["RequireDebuff"] and not z["RequireMyBuff"] and not z["RequireMyDebuff"] then
		i = 1
	end
	while z["RequireBuff"..i] or z["RequireDebuff"..i] or z["RequireMyBuff"..i] or z["RequireMyDebuff"..i] do
		for Aura in pairs(AuraFunctions) do
			if z["Require"..Aura..i] then
				if (z["RequireStack"..i] or 0) < 1 then
					z["RequireStack"..i] = 1
				end
				local Function = AuraStackFunctions[Aura]
				if z["RequireStack"..i] == 1 then
					Function = AuraFunctions[Aura]
				end
				if (Function(z["Require"..Aura..i], z["RequireBuffUnit"..i] or z.Unit, math.max(CastingTimeLeft, cooldown) + DoubleLag + (z["RequireMoreBuffTime"..i] or 0)) or 0) < z["RequireStack"..i] then
					return false
				end
			end
		end
		i = ( tonumber(i) or 0 ) + 1
	end
	local isUsable, notEnoughPower = IsUsableAction(slot)
	return ( z.EvenIfNotUsable or isUsable ) and ( z.NoPowerCheck or not notEnoughPower )
		and ( SUPPRESS_SPEED_CHECK or not z.NotWhileMoving or GetUnitSpeed("player") == 0 )
		and ( duration <= 1.5 or cooldown <= Lag + CastingTimeLeft or ( globalcooldown and cooldown <= 1.5 and cooldown <= globalcooldown ) )
		and ( not z.NotIfActive or ( not Current and not CastingOrChanneling ) or ( CastingOrChanneling and CastingOrChanneling <= Lag ) )
		and ( SUPPRESS_RANGE_CHECK or z.NoRangeCheck or UnitIsUnit(z.Unit, "player") or UnitIsUnit(z.Unit, "vehicle") or not ActionHasRange(slot) or IsActionInRange(slot, z.Unit) == 1 )
		and ( not z.EnemyTargetNeeded or s.Enemy(z.Unit) )
		and ( not z.TargetThatUsesManaNeeded or s.UsesMana(z.Unit) )
		and ( not z.DebuffSlotNeeded or not s.AllDebuffSlotsUsed(z.Unit) )
		and ( not z.Interrupt or s.GetCastingOrChanneling(nil, z.Unit, 1) > (CastingOrChanneling or (cooldown + z.CastTime)) + DoubleLag )
end

function s.CheckIfPetSpellCastable(z)
	if type(z.Name) ~= "string" then
		z.Name = s.SpellName(z.ID)
	end
	if type(z.Name) ~= "string" or ( not AddonTable.PetActions[z.Name] and not s.HasSpell(z.Name) ) then
		return false
	end
	if not z.Unit then
		if UnitExists("pettarget") then
			z.Unit = "pettarget"
		else
			z.Unit = s.UnitSelection()
		end
	end
	if Immune(z.ID, z.Unit) then
		return false
	end
	local CastingOrChanneling = s.CastingOrChanneling(z.Name, "pet")
	if not CastingOrChanneling and ( z.PetHealthNotNeeded or UnitHealth("pet") > 0 ) and ( not z.PetFrameNeeded or UnitExists("pet") ) then
		for n = 1, NUM_PET_ACTION_SLOTS do
			local name, subtext, texture, isToken, isActive = GetPetActionInfo(n)
			if subtext and subtext ~= "" then
				name = name.."("..subtext..")"
			end
			if ( AddonTable.PetActions[z.Name] or z.Name ) == name then
				local Lag = select(3, GetNetStats()) / 1000
				local DoubleLag = Lag * 2
				local CastingTimeLeft = s.GetCasting(nil, "pet")
				local cooldown, duration = s.PetActionCooldown(n)
				z.CastTime = z.CastTime or 0
				local i = ""
				if not z["Buff"] and not z["Debuff"] and not z["MyBuff"] and not z["MyDebuff"] then
					i = 1
				end
				while z["Buff"..i] or z["Debuff"..i] or z["MyBuff"..i] or z["MyDebuff"..i] do
					for Aura in pairs(AuraFunctions) do
						if z[Aura..i] then
							if (z["Stack"..i] or 0) < 1 then
								z["Stack"..i] = 1
							end
							local CastingQueued = 0
							if CastingOrChanneling then
								CastingQueued = 1
							end
							local Function = AuraStackFunctions[Aura]
							if z["Stack"..i] == 1 then
								if CastingQueued == 1 then
									return false
								end
								Function = AuraFunctions[Aura]
							end
							if (Function(z[Aura..i], z["BuffUnit"..i] or z.Unit, z.CastTime + math.max(CastingTimeLeft, cooldown) + DoubleLag + (z["EarlyRefresh"..i] or 0)) or 0) + (s.SpellOrAuraDelay(z[Aura..i], z.Unit) or 0) + CastingQueued >= z["Stack"..i] then
								return false
							end
						end
					end
					i = ( tonumber(i) or 0 ) + 1
				end
				i = ""
				if not z["RequireBuff"] and not z["RequireDebuff"] and not z["RequireMyBuff"] and not z["RequireMyDebuff"] then
					i = 1
				end
				while z["RequireBuff"..i] or z["RequireDebuff"..i] or z["RequireMyBuff"..i] or z["RequireMyDebuff"..i] do
					for Aura in pairs(AuraFunctions) do
						if z["Require"..Aura..i] then
							if (z["RequireStack"..i] or 0) < 1 then
								z["RequireStack"..i] = 1
							end
							local Function = AuraStackFunctions[Aura]
							if z["RequireStack"..i] == 1 then
								Function = AuraFunctions[Aura]
							end
							if (Function(z["Require"..Aura..i], z["RequireBuffUnit"..i] or z.Unit, math.max(CastingTimeLeft, cooldown) + DoubleLag + (z["RequireMoreBuffTime"..i] or 0)) or 0) < z["RequireStack"..i] then
								return false
							end
						end
					end
					i = ( tonumber(i) or 0 ) + 1
				end
				local globalcooldown = 0
				if not z.NoGCD then
					globalcooldown = nil
					local GlobalCooldownSpell = s.SpellName(z.GlobalPetCooldownSpell)
					if s.HasSpell(GlobalCooldownSpell) then
						globalcooldown = s.SpellCooldown(GlobalCooldownSpell)
					end
				end
				return not isActive and ( not z.DebuffSlotNeeded or not s.AllDebuffSlotsUsed(z.Unit) ) and ( z.EvenIfNotUsable or GetPetActionSlotUsable(n) ) and ( duration <= 1.5 or cooldown <= Lag or ( globalcooldown and cooldown <= 1.5 and cooldown <= globalcooldown ) )
			end
		end
	end
	return false
end


function s.BreakOnDamageCC(unit, DurationRemainingGreaterThan, Stealable, Dispelable)
	return s.Debuff(AddonTable.BreakOnDamage, unit, DurationRemainingGreaterThan, Stealable, Dispelable)
		or s.Debuff(19386--[[Wyvern Sting]], unit, DurationRemainingGreaterThan, Stealable, Dispelable, L["Asleep"])
end


function s.ImmunityDebuff(unit, DurationRemainingGreaterThan, Stealable, Dispelable)
	return s.Debuff(AddonTable.ImmunityDebuffs, unit, DurationRemainingGreaterThan, Stealable, Dispelable)
end


--all forms of fear and movement impairing affects are not included since they do not prevent the target from being damaged
--Mind Control is no longer included as a CC in this function
function s.NoDamageCC(unit, DurationRemainingGreaterThan, Stealable, Dispelable)
	return s.BreakOnDamageCC(unit, DurationRemainingGreaterThan, Stealable, Dispelable)
	or s.ImmunityDebuff(unit, DurationRemainingGreaterThan, Stealable, Dispelable)
end


--movement impairing affects are not included since the target could still attack
function s.CrowedControlled(unit, DurationRemainingGreaterThan, Stealable, Dispelable)
	return s.NoDamageCC(unit, DurationRemainingGreaterThan, Stealable, Dispelable)
	or s.Feared(unit, DurationRemainingGreaterThan, Stealable, Dispelable)
end


--movement impairing affects are not included since the target could still attack
function s.Feared(unit, DurationRemainingGreaterThan, Stealable, Dispelable)
	return s.Debuff(AddonTable.Fear, unit, DurationRemainingGreaterThan, Stealable, Dispelable)
end


function s.Rooted(unit, DurationRemainingGreaterThan, Stealable, Dispelable)
	return s.Debuff(AddonTable.Root, unit, DurationRemainingGreaterThan, Stealable, Dispelable)
end


function s.MovementImpaired(unit, DurationRemainingGreaterThan, Stealable, Dispelable)
	return s.Rooted(unit, DurationRemainingGreaterThan, Stealable, Dispelable)
	or s.Debuff(AddonTable.MovementImpairing, unit, DurationRemainingGreaterThan, Stealable, Dispelable)
end


function s.Poisoned(unit, DurationRemainingGreaterThan, Stealable, Dispelable)
	return s.Debuff(nil, unit, DurationRemainingGreaterThan, Stealable, Dispelable, nil, "Poison")
end

function s.Diseased(unit, DurationRemainingGreaterThan, Stealable, Dispelable)
	return s.Debuff(nil, unit, DurationRemainingGreaterThan, Stealable, Dispelable, nil, "Disease")
end

function s.Cursed(unit, DurationRemainingGreaterThan, Stealable, Dispelable)
	return s.Debuff(nil, unit, DurationRemainingGreaterThan, Stealable, Dispelable, nil, "Curse")
end

function s.Magic(unit, DurationRemainingGreaterThan, Stealable, Dispelable)
	return s.Debuff(nil, unit, DurationRemainingGreaterThan, Stealable, Dispelable, nil, "Magic")
end




function s.CheckThenFlash(z, NoFlash)
	local Flashed = nil
	if z.Type == "item" then
		if type(z.FlashID) == "table" then
			if s.Castable(z) then
				for _, ID in ipairs(z.FlashID) do
					if s.ItemFlashable(ID, z.FlashNoMacros) then
						if not NoFlash then
							s.FlashItem(ID, z.FlashColor, z.FlashSize, z.FlashBrightness, z.FlashBlink, z.FlashNoMacros)
						end
						Flashed = true
					end
				end
			end
		elseif s.ItemFlashable(z.FlashID or z.ID, z.FlashNoMacros) and s.Castable(z) then
			if not NoFlash then
				s.FlashItem(z.FlashID or z.ID, z.FlashColor, z.FlashSize, z.FlashBrightness, z.FlashBlink, z.FlashNoMacros)
			end
			Flashed = true
		end
	elseif z.Type == "vehicle" then
		if s.Castable(z) then
			if not NoFlash then
				if type(z.FlashID) == "table" then
					for _, ID in ipairs(z.FlashID) do
						s.FlashVehicle(ID, z.FlashColor, z.FlashSize, z.FlashBrightness, z.FlashBlink)
					end
				else
					s.FlashVehicle(z.FlashID or z.ID, z.FlashColor, z.FlashSize, z.FlashBrightness, z.FlashBlink)
				end
			end
			Flashed = true
		end
	elseif z.Type == "pet" then
		if s.Castable(z) then
			if not NoFlash then
				if type(z.FlashID) == "table" then
					for _, ID in ipairs(z.FlashID) do
						s.FlashPet(ID, z.FlashColor, z.FlashSize, z.FlashBrightness, z.FlashBlink)
					end
				else
					s.FlashPet(z.FlashID or z.ID, z.FlashColor, z.FlashSize, z.FlashBrightness, z.FlashBlink)
				end
			end
			Flashed = true
		end
	elseif z.Type == "form" then
		if s.Castable(z) then
			if not NoFlash then
				if type(z.FlashID) == "table" then
					for _, ID in ipairs(z.FlashID) do
						s.Flash(ID, z.FlashColor, z.FlashSize, z.FlashBrightness, z.FlashBlink, z.FlashNoMacros)
						s.FlashForm(ID, z.FlashColor, z.FlashSize, z.FlashBrightness, z.FlashBlink)
					end
				else
					s.Flash(z.FlashID or z.ID, z.FlashColor, z.FlashSize, z.FlashBrightness, z.FlashBlink, z.FlashNoMacros)
					s.FlashForm(z.FlashID or z.ID, z.FlashColor, z.FlashSize, z.FlashBrightness, z.FlashBlink)
				end
			end
			Flashed = true
		end
	elseif type(z.FlashID) == "table" then
		if s.Castable(z) then
			for _, ID in ipairs(z.FlashID) do
				if s.Flashable(ID, z.FlashNoMacros) then
					if not NoFlash then
						s.Flash(ID, z.FlashColor, z.FlashSize, z.FlashBrightness, z.FlashBlink, z.FlashNoMacros)
					end
					Flashed = true
				end
			end
		end
	elseif s.Flashable(z.FlashID or z.ID, z.FlashNoMacros) and s.Castable(z) then
		if not NoFlash then
			s.Flash(z.FlashID or z.ID, z.FlashColor, z.FlashSize, z.FlashBrightness, z.FlashBlink, z.FlashNoMacros)
		end
		Flashed = true
	end
	return Flashed
end


function s.FlashSizePercent()
	return FLASH_SIZE_PERCENT or DEFAULT_FLASH_SIZE_PERCENT
end

function s.FlashBrightnessPercent()
	return FLASH_BRIGHTNESS_PERCENT or DEFAULT_FLASH_BRIGHTNESS_PERCENT
end

function s.Flashable(SpellName, NoMacros)
	return SpellFlashCore.Flashable(SpellName, NoMacros or DISABLE_MACRO_FLASHING)
end

function s.Flash(SpellName, color, size, brightness, blink, NoMacros)
	SpellFlashCore.FlashAction(SpellName, color, size or FLASH_SIZE_PERCENT or DEFAULT_FLASH_SIZE_PERCENT, brightness or FLASH_BRIGHTNESS_PERCENT or DEFAULT_FLASH_BRIGHTNESS_PERCENT, blink or ENABLE_BLINKING, NoMacros or DISABLE_MACRO_FLASHING)
end

function s.ItemFlashable(ItemName, NoMacros)
	return SpellFlashCore.ItemFlashable(ItemName, NoMacros or DISABLE_MACRO_FLASHING)
end

function s.FlashItem(ItemName, color, size, brightness, blink, NoMacros)
	SpellFlashCore.FlashItem(ItemName, color, size or FLASH_SIZE_PERCENT or DEFAULT_FLASH_SIZE_PERCENT, brightness or FLASH_BRIGHTNESS_PERCENT or DEFAULT_FLASH_BRIGHTNESS_PERCENT, blink or ENABLE_BLINKING, NoMacros or DISABLE_MACRO_FLASHING)
end

function s.VehicleFlashable(SpellName)
	return not not VehicleSlot(SpellName)
end

function s.FlashVehicle(SpellName, color, size, brightness, blink)
	SpellFlashCore.FlashVehicle(SpellName, color, size or FLASH_SIZE_PERCENT or DEFAULT_FLASH_SIZE_PERCENT, brightness or FLASH_BRIGHTNESS_PERCENT or DEFAULT_FLASH_BRIGHTNESS_PERCENT, blink or ENABLE_BLINKING)
end

function s.FlashPet(SpellName, color, size, brightness, blink)
	SpellFlashCore.FlashPet(SpellName, color, size or FLASH_SIZE_PERCENT or DEFAULT_FLASH_SIZE_PERCENT, brightness or FLASH_BRIGHTNESS_PERCENT or DEFAULT_FLASH_BRIGHTNESS_PERCENT, blink or ENABLE_BLINKING)
end

function s.FlashForm(SpellName, color, size, brightness, blink)
	SpellFlashCore.FlashForm(SpellName, color, size or FLASH_SIZE_PERCENT or DEFAULT_FLASH_SIZE_PERCENT, brightness or FLASH_BRIGHTNESS_PERCENT or DEFAULT_FLASH_BRIGHTNESS_PERCENT, blink or ENABLE_BLINKING)
end

function s.FlashTotemCall(color, size, brightness, blink)
	SpellFlashCore.FlashTotemCall(color, size or FLASH_SIZE_PERCENT or DEFAULT_FLASH_SIZE_PERCENT, brightness or FLASH_BRIGHTNESS_PERCENT or DEFAULT_FLASH_BRIGHTNESS_PERCENT, blink or ENABLE_BLINKING)
end

function s.FlashTotemRecall(color, size, brightness, blink)
	SpellFlashCore.FlashTotemRecall(color, size or FLASH_SIZE_PERCENT or DEFAULT_FLASH_SIZE_PERCENT, brightness or FLASH_BRIGHTNESS_PERCENT or DEFAULT_FLASH_BRIGHTNESS_PERCENT, blink or ENABLE_BLINKING)
end

function s.FlashFrame(frame, color, size, brightness, blink)
	SpellFlashCore.FlashFrame(frame, color, size or FLASH_SIZE_PERCENT or DEFAULT_FLASH_SIZE_PERCENT, brightness or FLASH_BRIGHTNESS_PERCENT or DEFAULT_FLASH_BRIGHTNESS_PERCENT, blink or ENABLE_BLINKING)
end

